// ===================================================================
// ====   BALM10beep    générateur UHF , balise  pour manips      ====
// ====   ballon sonde météo M10, pll ADF7012B,GPS Sierra, Nano   ==== 
// ====   version 1.0                   F5BEZ Dominique LEVEQUE   ====
// ===================================================================

#ifndef BALM10beep_h
#define BALM10beep_h

// commun aux modules  
#if defined(ARDUINO) && ARDUINO >= 100
 #include "Arduino.h"
#else 
 #include "WProgram.h"
#endif

#include <Wire.h>
#include <Time.h>
#include <TimeLib.h>
#include <SPI.h>

#pragma message  ">>> BALM10beep V1.0 build 2/2/2020 <<<"
//#pragma once   // infos pour precompil et compil pour filtre messages 
//#pragma GCC diagnostic error "-Wall" //"-Werror"
//#pragma GCC diagnostic error "-Werror"


// ============ define programme ================================================
#define  VITBAUDUSB 115200 // IDE arduino    mode outils/monitor série/ en bas milieu mettre 115200
// def  ou pas  (si en // )  selon types sorties installés
//   non  si ancien M10  Trimble copernik préalablement reprogrammé pour out nmea 
#define FONCTIONSGSPSIERRA           // oui si M10 gps avec sierra 2020  // de base si pas  bluetooth oui
#define FONCTIONSBLUETOOTH           // oui si bluetooth     
#define FONCTIONSRXCW1CAR            // oui   partiel 1 lettre    ( extrait de appli f5zeh 2 lettres sur rx auxiliaire uhf) )
#if defined(FONCTIONSBLUETOOTH)      // si arduino xxx  ou teensy 3.x  avec Serial physique 1 ou 2
// #define Serialbluetooth Serial1   // que si teensy   serial1  hard   pin cf doc
#endif                               // en Nano voir à fonction SoftwareSerial

//#undef  nnnn           //si conflit
// ----------- Define const standards -------------------------------------------

#define ON      1    
#define OFF     0
#define OK      1
#define NOK     0
#define	VRAI		1     // TIP : VRAI est remplacé par 1  à la compilation préprocesseur , ce n'est pas une variable
#define	FAUX		0     // TIP : mais permet une lecture plus naturelle du code
#define OUI     1     // TIP : 
#define NON     0     // TIP 
#define	TRUE		VRAI  // TIP : et une recherche generale dans les sources par le mot cle approprié
#define	FALSE		FAUX
#define	LF	    0x0A    // LF  \n       // divers ASCII    !  att selon  __c   c'est "\n"
#define CR	    0x0D    // CR  \r        // 
#define	SPACE	  0x20    // SP      ou " "
#define NUL0	  0x00    // NULL	0x00  NULL is already predefined as ptr
#define TXON    ON    
#define TXOFF   OFF    
#define KUP     1       // key up 
#define KDOWN   0       // key down 
#define NOTXT   "x"     // rien
#define NOVAL   -1      // pas de parametre valeur  balinfos mais permet aff de 0
#define BEEPOK1 1  
#define BEEPOK2 BEEPOK1       // ex 2 3 4
#define BEEPOK3 BEEPOK1       
#define BEEPOK4 BEEPOK1  
#define BEEPNOK 5  
#define VOIEPC  0       // saisie par le pc  
#define VOIEBT  1       // saisie par le bt
#define OUTGPS0  0      // sortie pc ou pin 1  vitesse  pc usb 
#define OUTGPS1  1      // sortie (pc) pin 1 vitesse NMEA  et BT
#define OUTGPS2  2      // idem 2 mais en continu
#define STATUTRXGPS0 0    // déf
#define STATUTRXGPS1 1    // caracts reçus 
#define STATUTRXGPS2 2    // $  reçu
#define BUG     FAUX      // mais c'est pas certain... 
#define VIRUS   FAUX      // mal fichu ?  au moment de finaliser  ça , le coronavirus gagne du terrain...
#define INTEL   8080      // j'ai donné !! en INTEL_ligence ART_ificielle  // intelligence artificielle terme à la mode !!!

// ----------- Define choix type de board module hard et assignation des pins selon le cas -----------------------------
// rev 2  les N° pin étant définis et commun , ils ne sont plus en variables byte et passage par paramètres aux classes
// pour gain en ram, donc dans cette appli il n'y a pas plusieurs instances avec des n° pin différents cf f5zeh...
// affectation du module physique
// www.pjrc.com Teensy2   atmega32U4 8 bit AVR 16Mhz  flash 32K ram 2560 eeprom 1024 I/0 25 dont analog 12 pwm 7 uart 1 et usb
//#define TEENSY2         // voir affectation des pins   tout n'est pas possible   simultanément tout comme uno nano ...
//#define TEENSY2PP       // Teensy 2++   flash 130k  ram 8192 eeprom 4k I/O 46  toutes options possibles 
//#define TEENSY32        // Teensy 3.2   petit et permet bien plus   app f5bez multifonctions  mesures gps nav 
//#define LEONARDO        // arduino essai
//#define UNO             // arduino std Atmega328P  en gros idem Nano mais plus grand 
#define NANO              // arduino std ( V3  Atmega328P )   BALM10beep  février 2020   NANO  petit  mais au  maxi de ses ressources  !!!
// --------- affectation N° pin    ordre pin         N° arbitraires  90..99  si non utilisés ou masqués  
// connectivité !! att. 5v - 3,3v  soit par des interfaces à FET, soit par des R 2,2K qui limitent et protègent , empirique mlais fonctionnel ici. 
#if defined(NANO)
#define RXD        0     // réservé utilisé usb    Serial  possible mais contrainte branchement et débranchement usb programmation
#define TXD        1     // réservé utilisé usb    S_PTOSERIALUSB à 0 et redirection trames gps gga rmc avec Serial directement
#define PRXGPS     2     // Rx du GPS NMEA ttl 5v     reçoit le Tx du gps en 3,3v   avec R 1k à 2k en  protection
#define PTXGPS     3     // Tx vers GPS ttl 5v        emet le Tx du nano en 5v vers gps en 3,3v avec R 2,2k   'limitation '  protection
#define LEDROUGE   4     // D4    1K  info cycle   
#define LEDVERTE   5     // D5  270ohms cycle hors tx 
#define LED_PIN  LEDVERTE
#ifdef FONCTIONSBLUETOOTH
  #define INPrxblue    8  // voir prérequit bluetooth       pin en Rx pour Teensy2 0..4 ou 13,14,15 
  #define OUTtxblue    9  // 
#endif
#define PWRPAPIN       7  // M10 substitute du uC ordre tx pour tr driver et power alim vcc 5v du tr PA  
#define ADF7012_TX_DATA_PIN   6   
// out SPI   deb  // out NANO >>>>   via R de 2,2 ou 2,7kohms ou mieux via interface MOS 5v-3,3v  quadruple   ebay
#define SSpin        10   // SS    vers pin 13 LE
#define SCKpin       13   // SCK   vers pin 11 clk
#define MOSIpin      11   // MOSI  vers pin 12 data
// out spi end  MISO N.U. le adf ne cause pas comme esclave vers Nano maître !
#define BT1CTRL      12    // bt contrôle  stop  ou commandes  cw      en mode  pull-up  push down à 0    
// analogique A/D
#define CTRLATHF   A0    // diode out antenne M10     // ou Pwr  directe par coupleur si PA
#define CTRLEVEXT  A1    // événement externe beep alarme  47K au +3v et bt vers masse OU U analogique > ou < à un seuil selon mis en prg
#define CTRL12V    A2    // R1 R2  22k / 5,6K        rp  3,93 selon R  //NU sauf si alim externe 12v labo ou voiture en amont d'un 7805 
#define CTRL05V    A3    // R1 R2  15k / 15k         rp  2             // U battreie piles M10
// pin Analog  A4  A4    // NU réservées I2C      // AD4   réservés    // A4 A5 réservés  SDA/SCL
// pin Analog  A5  A5    // NU réservées I2C      // AD5   réservés 
  // pin 6 du adf  via une 1K de protect   
// si état on off  lire 0 ou 3,3v  si  analog pwd max 3,3v donc env 675  5v réf nano  défaur  1024 
#define ADMUXADFPIN A6   // ADF7012 MUXOUT <<<<<< plusieurs usages selon codage registre 
#define BTSPRESET   A7    // Bt préset canaux 1 2 3   à défaut mettre 2,7k vers masse 

#if defined(FONCTIONSIRREMOTE)   // pour mémo  cf  multifonctions
  #define INPrxIR      93 // input  Rx IR pat télécommande IR  avec une ex télécommande de tv
#endif

/* lignes  non utilisables en Nano
//PWM Pins  PWM Frequency Uno, Nano, Mini  3, 5, 6, 9, 10, 11  490 Hz (pins 5 and 6: 980 Hz    à éviter car pas 0v sûr car temp idem delay)
//#define BUZZER      92    // buzzer beep à osc interne ou led    ou si lame piezzo faire avec fct note ou digital pwm à 1khz  // M10 buzzer recherche audio finale !  //wspr acq  
//#define OUTSAVEPWR  3    // out cde off des régulateurs 3,3v du gps et du PLL du M10  mise en sommeil pour conso minimum
//#define INPINT1PPS  3    // 2 ou 3 déjà pris en Nano Uno  pour serial gps      interruption
//#define INPEVEXT    9  //  que A1          input evenement externe   capteur  alarme  actif à 0         test Alarme interr testé
#define RESET      9    // cf  base UNO   //or 10// ?    
#define FQ_UD     10    // cf  base UNO  
//      DATA      11    // NU    via init dds  SPI.setBitOrder(LSBFIRST);   SPI.setDataMode(SPI_MODE0);   // si open  pas dds ?  set 0 hard ?
#define W_CLK     13    // cf  base UNO     
//  mesure AD température placé dessus XTAL 125M  AD9850    capteur TMP36   0,7v / 20°   découplage  nécessaire en HF
//#define CAPTTEMP   A7  // AD7  the analog pin the TMP36's Vout temp capteur dessus le xtal 125M AD9850 
  
*/
#endif
// -------------
//#if defined(UNO)
// très proche nano  à tester
//#endif
// -------------
// ----------------------------------------------------------------------------------------------
/*
#if defined(TEENSY32)
// permet serial1 hard   et fonctions  location  locator traking gps avec  tx  modes  aprs et ft8  clock 
#endif
*/

// -------- Define textes balise personnalisation  ----------------------------------------------
  
#define MAXSIZEBUFFER    31    // pour Buff !! prérequit  attention pas de test sizeof ( ) donc ...
#define TEMPSMAXVEILLE   600   // 1mn

// -------- Define textes noms paramètres   --------------------------------------------------------------------------

 #define NBRPARAMS      15    // 0..n   ordre paramètres en eeprom et en lecture contrôle par cde  

 #define P_BAL_CLE       0    //             repère  eeprom
 #define P_SYNCHRO       1    // param   Séquence 1 base    réserves   2...  autres
 #define P_SYNCSKIP      2    // param   Séquence 0 toutes   n  skip passes  option
 #define P_POWERMODE     3    // param   Séquence choix power  choix trame précodées 1 base 0 , 2 15,  3, 30dbm  avec cdes our R 1 et 2  
 #define P_POWERSEQ      4    // param   Séquence n niveaux de puissance   successifs  option     
 #define P_FREQCANAUX    5    // param   Séquence choix canal  fréq.
 #define P_TYPEDEMODUL   6    // param   Séquence 0 sans   n    choix 
 #define P_BEEPSECONDE   7    // param   Séquence 0 sans 1..5  beep chaque x sec
 #define P_BEEPMINUTE    8    // param   Séquence 0 sans 1 idem sec  2 à 4 pour 5,10,20 sec
 #define P_MESSINDCW     9    // param   Séquence si message cw nécessaire à H ?  
 #define P_HEURELOC     10    // param   Séquence le gps reçoit H UTC  ajout affichage  0 , +1 hiver  , +2  été
 #define P_FIXEMOBILE   11    // param   Séquence trame  fixe ou  régénérée  via position GPS 
 #define P_SCHEDULE     12    // param   Séquence 0 sans  batch/macro/happing     config  pwr band  sur cycle 24h  
 #define P_RELAIS1      13    // param   Séquence  action set reset relais 1  relais base ou relais à mémoire magnétique si avec P_RELAIS2
 #define P_RELAIS2      14    // param   Séquence  action set reset relais 2  
                    
#define NBRSYSTEM        6    //10    // index var  appli  en ram

#define S_BACTIVE        0    // etat    Séquence    1 mode sequences balise       0  mode en veille arrêt balise 
#define S_BSOMMEIL       1    // etat    Séquence    0 normal 1 cde pour Tr npn  pour couper alim 3,3v existantes  du pll et du gps 
#define S_ALARME         2    // état    Séquence    0 sans  1  avec prise en compte des alarmes     
#define S_SIMUL          3    // état    Séquence    0 normal déf   1 raccourcis  dév.
#define S_PTOSERIALUSB   4    // etat    Systeme     mode sortie  'print' vers usb   base standard  
#define S_PTOBLUETOOTH   5    // etat    Systeme     mode sortie  'print' vers serial bluetooth 



// ------------ macros -----------------------------------------------------------
// 
// pour les chaines constantes (entre " ") rangees en mémoire programme flash pour libérer le max de ram.
// pour les chaînes dynamiques comme Buff   NB NB certains appels sont avec { } nécessaires
#define balprint(string,valeur) balprintinfos(PSTR(string),valeur);
#define balprintln(string,valeur) balprintinfosln(PSTR(string),valeur);
#define balprintbuff(string,valeur) balprintinfosbuff(string,valeur);
#define balprintbuffln(string,valeur) balprintinfosbuffln(string,valeur);

// idem avec N° trace 
#define baltrace(numtrace,string,valeur) baltraceinfos(numtrace,PSTR(string),valeur);   // 
#define baltraceln(numtrace,string,valeur) baltraceinfosln(numtrace,PSTR(string),valeur);
#define baltracebuff(numtrace,string,valeur) baltraceinfosbuff(numtrace,string,valeur);
#define baltracebuffln(numtrace,string,valeur) baltraceinfosbuffln(numtrace,string,valeur);

#define balprintc(caract) balprintcar(caract);             // que caractere  et en direct rapide
#define balprinti(valeur) balprintint(valeur);             // que valeur et en direct rapide
#define balprints(string) balprintinfos(PSTR(string),NOVAL);          // que string
#define balprintv(valeur) balprintinfos(NOTXT,valeur);                // que valeur
#define balprintsln(string) balprintinfosln(PSTR(string),NOVAL);          // que string
#define balprintvln(valeur) balprintinfosln(NOTXT,valeur);                // que valeur
#define balprinttexteln(string) balprintinfosbuffln(string,NOVAL);        // que buff 
#define balprintretourligne  balprint("\r\n",NOVAL);  //   \r retour ligne  \n  newline 

#define baltraces(numtrace,string)  baltraceinfos(numtrace,PSTR(string),NOVAL);   // s comme string seule
#define baltracesln(numtrace,string)  baltraceinfosln(numtrace,PSTR(string),NOVAL);

//--------------------------------

#define VITESSECW         14                   //mots / Mn
#define MODEMODULPORTEUSE 0
#define MODEMODULBEEPCW   1
#define MODEMODULBEEPFM   2
#define MODEMODULBEEPAM   3
#define TXPOWERLOW        1   
#define TXPOWERHIGH       2   
// M10  le uC est conservé comme osc réf 8Mhz qui est déjà câblé vers le ADF Xtal inp pin 9
// option le xtal 16Mhz du NANO  soit direct soit div /2  cmos 3,v soit div /2 soft et pin out puis r/R pour 3v
#define QUARTZUC8M  8000000L    //  le xtal du uC du M10
#define TXPOWERLOW        1    // que le PLL   'à travers '      env 10dBm           
#define TXPOWERHIGH       2    // cde alim du petit PA           env 23dBm  cf 200mW ?


// out NANO >>>>   via interface MOS 5v-3,3v  quadruple mosfet   ebay ou via R 2,2k ou 2,7k tampon ...
// prévu pour modul  ask ( >>AM<< )    ;   fsk ou autres mais avec clock en plus dfe data  cf la docu pdf du adf pll
#define FREQUENCEDEFM10   400000000   // 
// >>>  observé sur le module M10 ici  
// gamme testée 387 à 428Mhz   ne monte pas à 430..440  voir self  pll ou optimiser régistres pll ?? 
// précision du 8MHz !!  
// 400 demandé 399980 entendu  -20  // 390020   entendu à 391980 !!! soit +1960khz      voir à registre correction
#endif

// --------- autres moyens pour mémoires sur d'autres applis  domotic
//#if defined(FONCTIONIRREMOTE)      // idem appli multifonctions f5bez    pour infos des modes de commandes autres
//#include <IRremote.h>  //https://www.pjrc.com/teensy/td_libs_IRremote.html   Ken Shirriff  * http://arcfn.comtransmit pin 5 pour Teensy 3.1  timer CMT#
//#endif
   //#if defined(FONCTIONSRADIODTMF)  // idem applis relais f1zbx f5zby  de f5bez            
   //#if defined(FONCTIONSWEBSERVEUR) // bloc module wifi   mode page web serveur  php  fct domotique  f5bez   à revoir en teennsy 4
   //#if defined(FONCTIONSTEL3GSMS)   // bloc module telph 3G   cde et infos par sms  fct domotique  f5bez
//memo en-tete ici  type de lcd 1       std  HD40780
//#include <LiquidCrystalFast.h>  //http://www.pjrc.com/teensy/td_libs_LiquidCrystal.html
//LiquidCrystalFast lcd(PINlcd_rs,PINlcd_rw,PINlcd_e,PINlcd_D4,PINlcd_D5,PINlcd_D6,PINlcd_D7); // initialize the library // lcd "162B" ( RadioSpares ) 
//lcd.begin(LCD_DISP_LENGTH, LCD_LINES);
//lcd_bargraph_init();  // Initialize the LCD bargraph, load the bargraph custom characters
// type de lcd 2   expl de f4goh rtcOled    tout petit   I2C   moins de fils 
//#include <Adafruit_GFX.h>           // type LCD   N.U.
//#include <Adafruit_SSD1306.h>
//Adafruit_SSD1306 lcd;

// build 2/2/20
//Le croquis utilise 30120 octets (98%) de l'espace de stockage de programmes. Le maximum est de 30720 octets.
//Les variables globales utilisent 1516 octets (74%) de mémoire dynamique, ce qui laisse 532 octets pour les variables locales. Le maximum est de 2048 octets.

// Dominique LEVEQUE F5BEZ 
// ==============================================================================================================
