// ===================================================================
// ====   BALM10beep    générateur UHF , balise  pour manips      ====
// ====   ballon sonde météo M10, pll ADF7012B,GPS Sierra, Nano   ==== 
// ====   version 1.0                   F5BEZ Dominique LEVEQUE   ====
// ===================================================================

#include "BALM10beep.h"            // voir en 1er :  pins, #define , macros
#include "BALbfonctions.h"
#include "BALbsoftclock.h"
#include "BALbgestionbeep.h"   
#include "Balbadf7012.h"
#include "BALbgpstoclock.h"      
#include "BALbtelecomcw.h"  
#include "BALbmorseTx.h"
#include "BALbconfigeepr.h"  

// ---------- variables globales à l'ensemble ------ 1er Caractère en majuscule ---------------
byte Parbalise[NBRPARAMS];     //¨Paramètres des fonctionnalités updatés ( mis à jour )  en EEprom 
byte Sysbalise[NBRSYSTEM];     // Systeme  variables non eeprom
char Buff[MAXSIZEBUFFER] =      "012345678901234567890123456789"; // 30  buffer général   ATT !! à sizemax dans prg car pas de tests strlen(Buff) pour  gain place
byte Balnumcommande = 0;       // param  N°  test 1..19   21..99    0 acquitté  // debug mettre N° si test avant cycle   , sera acquité 
byte Balaction = 0;            // N°de la commande...
int  Balpasseveille = 0;       // N° passes dans bcle principale pour remise  imposée en mode balise
bool Flagpasseaff = FAUX;      // affichage des états en cours balise à Mn ou si cght d'un paramètre
byte Pulseled = 0;             // impulsion des secondes led verte 
byte SecPrec = 0;              // seconce précédente, pour cycle seconde
byte HeureSch = 0;             // heure pour schedule ( planifications horaires )      
byte Indexcanaux = 4;          // 3 canaux  123 4 def et saisie
byte Indexpower = 1;           // 1 pll seul ou 2 avec le petit driver
byte Cptskiptx;                // compteur des passes ' sautées '  
byte Etatalarme = 0;           // 1 par interrup,  2 par seuil AD,  3 par 

//volatile byte Flagpulse1pps = 0; // prévu reprise 1PPS du GPS pour manip temps plus précises
//
// ============================================================================================
// 
void setup() 
{
  Serial.begin(VITBAUDUSB); // std en mode liaison usb - pc  IDE arduino : outils/monitor série , en bas à droite : 'les deux NL et CR ' , ' 115200' 
  Sysbalise[S_PTOSERIALUSB]  = OUI;   // mode sortie initial par défaut  et/ou    Sysbalise[S_PTOBLUETOOTH]  = 1;  
  Sysbalise[S_PTOBLUETOOTH]  = OUI;   // si installé
  balinitbluetooth();   //   bluetooth     option  
  balintrostart();      //  intro. dév. 
  balinitvoiesAD();     //  set et 1 passe lecture initiale voies AD 
  balsetpinsdir();      //  set pins directions input ou  output
  balsetdefparams();    //  set params par défaut du programme  ( fct 'r' )
  balstartmodes();      //  gestion démarrage
  balswitchparams();    //  surcharges par switches ( si implantés  )   
  baladfinstall();      //  init adf7012 PLL  
  balgpsinstall();      //  init gps sierra M10 > 2019 
  Lestatut = balreadbconfig(); // dont indicatif et Fréq de base ( canal 4)
  balpresettime();       // cde interne soft Time    manip   ici  sans la clock  rtc  DS3231
}
//
// ============================================================================================
// 
void loop() 
  {    
    byte secondecycle;
    if (( Pulseled == 0) && (Sysbalise[S_BSOMMEIL] == NON))  digitalWrite(LEDVERTE,ON); 
    delay(100);  // >>>>>>>>>>>>>  cadence  loop de base  100ms  non préemptif <<<<<<<<<<<<<<<<<<< mais suffit pour cette manip M10
   // NB  balsmartdelay(100);      // alternative cf  multifonctions  delay non bloquant   f5zeh  interr. préemptif
   // exemple en dev  pour test de fct  hors appli globale 
   // balgpstestraw(1);   ou   //balsynchrogpsclock(0);   ou autre
   // while(1);   // et stop là  
//---------- (télé)commandes modes et fonctions par différentes sources -------------------
// A10   si un test est armé par prg en init   exécution acquittement en retour  et séquence ensuite     
   if (Balnumcommande > 30 && Balnumcommande < 90 ) Balnumcommande = balfonctionstests(Balnumcommande);  //cf balsequence.baltestfonctions(Balnumcommande);  de BALf5zeh
// A12  si une commande en télécommande par PC est armée  en attente saute le cycle et l'exécuter  NB ici arrêter d'abord mode balise avec bt ou 'enter' 
   Balaction = balreceptioncdepc();         // en 1er   
   #if defined (FONCTIONSBLUETOOTH)
   // A14 si une liaison bluetooth et une télécommande par Prg ou Terminal Samrtphone est armé    , idem
   if ( Balaction == 0 ) Balaction = balreceptioncdebt();
   #endif
  //#if defined (FONCTIONSIRREMOTE)     // une ex télécommande TV et  son Rx IR  récup   1 touche affectée pour 1 commande  mais pas tout !
// A16 si une reception d'ordres par touches télécommandes IR de TV  et transfert touche > 1 lettre > action
    // if ( Balaction == 0 )  Balaction = balreceptioncenir();   
  //#endif
   #if defined (FONCTIONSRXCW1CAR)
// A18 si une reception d'ordres par smart bt façade cw   >  1 lettre  > action
  if ( Balaction == 0 )  Balaction = balreceptioncencw();  
   #endif
// >> autres moyens pour mémoires sur d'autres applis  domotic
   //#if defined(FONCTIONSRADIODTMF)  // idem applis relais f1zbx f5zby  de f5bez            
   //#if defined(FONCTIONSWEBSERVEUR) // bloc module wifi
   //#if defined(FONCTIONSTEL3GSMS)   // bloc module telph 3G   cde et infos par sms
// si une action en demande d'exécution  variable Sys... changée et acquittement
// A34 en mode veille ou cycle à la fin des séquences  si une action  
  if (Balaction > 0 )  {   Balaction = balmodifsys(Balaction);     }
 
// -------- fin pour commande s'il y a -------  
 //!NU balgetboutons();    // lire boutons préset 1 , 2 , 3   enlevé pour gain ram
 Balpasseveille++;   // compteur passes dans ce loop ( boucle )   
// -------- cycle par 100 milliseconde --------
  if ((Sysbalise[S_BACTIVE]  == VRAI ) && (Pulseled++ > 3)) digitalWrite(LEDVERTE,OFF);  // fin pulse 300ms led verte
  secondecycle = ballireclock();  // cycle seconde avec Time en M10   // pas de  rtc
  
  if (SecPrec != secondecycle)    // au changement de seconde   
  {
  //digitalWrite(LEDVERTE,ON);  Pulseled = 0;
  // ---------------------- cycle par seconde --------------------------  
  if (secondecycle == 0) { balprintretourligne;  balaffcycledate(); }    // début de cycle mn
  if ((Parbalise[P_SCHEDULE] > 0) && (secondecycle == 0)) { HeureSch = balaffcycleqtr(); }
  if (Parbalise[P_SCHEDULE] == 0)  { if (secondecycle % 10 == 0 ) { HeureSch = balaffcycleqtr(); } else  { sprintf(Buff," %02d",secondecycle );  balprintinfosbuff(Buff,NOVAL);  }} //  pour sec de 1 à 9 en 01 à 09
  //-- cycle balise       
  balgetinfoalarme();   if ( Etatalarme > 0 )   { balactionsuralarme();  Etatalarme = 0;  }  // do and ack   // test par seconde

  if (( Parbalise[P_MESSINDCW] == VRAI ) &&  (( secondecycle == 1 ) || (( Parbalise[P_BEEPMINUTE] > 1  ) &&  ( secondecycle == 30)))) { balenvoieindicatif(); }
  
  if (Parbalise[P_SCHEDULE] > 0 ) balmodesschedule(); else balpresetboutons();   //0 sans preset bt si armé 

  if (Sysbalise[S_BACTIVE]  == VRAI )  // 1 active,  0  en veille  
  {
   digitalWrite(LEDVERTE,ON);  Pulseled = 0; 
   if (Parbalise[P_SYNCHRO] == 1 )  // 1 = mode de base   
   {  
   //NU if (( secondecycle == 58  ) && ( Parbalise[P_FIXEMOBILE] == VRAI )) balgenerertrame();  // 57 58//-- cas special si mobile
   //NU if (secondecycle == 58)    balselectpwrpa();        // // 58 59    set sorties pour PA anticipés pour temps action relais 
   //NU if (Sysbalise[S_SIMUL] == 1)  { baltraces(10,"Simul mn");  balselectpwrpa(); delay(2000); }  //
   if  (baltestcycleseconde())                //  ||  ( Sysbalise[S_SIMUL] == 1 ))          
    {
    // baltraceln(12,"Synch:",Parbalise[P_SYNCHRO]);      // que 1   prévu si évolution 
    digitalWrite(LEDVERTE,OFF);
      balmoduleM10(secondecycle);  // nb timing bloqué en séquence      pas de méthode interrup préemptive ici
    digitalWrite(LEDROUGE,OFF);  // 
    }  // du type 1  
  }  // methode synchro 1  std  
 }  // mode balise ON

 else
 { // en veille 
    balpresetboutons();  // si armé
    if (Sysbalise[S_BSOMMEIL] == NON) digitalWrite(LEDVERTE,ON);     // en sommeil pas de conso sur led verte horaire
    if (( Parbalise[P_TYPEDEMODUL] ==  MODEMODULPORTEUSE ) && ( Balpasseveille == 1 ))   balsettxoff(); // 1 passe 
    if (( Balpasseveille >  TEMPSMAXVEILLE ) && ( Parbalise[P_SCHEDULE] == 0  ))
     {
     Sysbalise[S_BACTIVE]  = VRAI;       // retour auto  sauf si en schedule horaire H
     balprintretourligne;  
     baltracesln(14,"Start Sy1");  
     Balpasseveille = 0;
     }
  }// fin en veille //
 SecPrec = secondecycle;  // termine fin cycle seconde  
 } // fin cycle seconde   //if ( !VIRUS && !INTEL )  continue;  _ou_  !( VIRUS || INTEL ) continue aussi;  // disait karnaugh
}  // main loop  do { ceprogramme(); }  while((pas_de_panne || pas_de_bugs ) && du_jus);  // sinon réclamer à f5bez-4@orange.fr
// ----------------------------------------------------------------------------------------------------------------------------
// version V1.0   2/2/2020    M10  beeps réglables et cw           400Mhz  et plus  modèle gps Sierra
// version V0.9   2011..2015  M2K2 et 1er M10 gps Trimble          réutilisation du GPS directement  idem à EM406A     
// version V0.8   4/10/1957   beeps simples seuls  20 et 40 Mhz    https://fr.wikipedia.org/wiki/Spoutnik 

// Il n'y a pas de Colossus dispo aussi un plus petit arduino Nano fera l'affaire  https://fr.wikipedia.org/wiki/Colossus_(ordinateur)                                                           
// C-plus facile que l'origine en trinaire récursif                                https://fr.wikipedia.org/wiki/Alan_Turing

// arduino    https://fr.wikipedia.org/wiki/Arduino       NANO ( officiel ) https://store.arduino.cc/arduino-nano                      
// outil de développement  V1.8.12   https://www.arduino.cc/en/Main/Software
// outil complémentaire    V1.51     https://www.pjrc.com/teensy/td_download.html
//>>> Le croquis utilise 30064 octets (97%) de l'espace de stockage de programmes. Le maximum est de 30720 octets.
//>>> Les variables globales utilisent 1606 octets (78%) de mémoire dynamique, ce qui laisse 442 octets pour les variables locales. Le maximum est de 2048 octets.
//>>> La mémoire disponible faible, des problèmes de stabilité pourraient survenir.   
//>>> C'est les derniers mots que me dit en bas en rouge mon IDE Arduino  si > 75%  !!! 
//>>> donc si le nano pète je ne réponds de rien, à vos risques et périls...

// Dominique LEVEQUE F5BEZ 
// ==============================================================================================================
