// ===================================================================
// ====   BALM10beep    générateur UHF , balise  pour manips      ====
// ====   ballon sonde météo M10, pll ADF7012B,GPS Sierra, Nano   ==== 
// ====   version 1.0                   F5BEZ Dominique LEVEQUE   ====
// ===================================================================

// base partielle   pecan copyright (C) 2012  KT5TK

#ifndef BALbadf7012_h
#define BALbadf7012_h

#include "BALM10beep.h"

class Radio {};

class RadioAdf7012 : public Radio {
  public:
    virtual void setup();
    virtual void ptt_on();
    virtual void ptt_off();
    virtual void set_freq(unsigned long freq);
    virtual int get_powerlevel();


     // rajoutées
     virtual void adf_setpwretat(bool etat);
     virtual void adf_setpwrlevel(int pwrlevel);
     virtual void adf_setmodultype(byte modtype);
     virtual void adf_setmodullevel(int modlevel);
     //virtual void RadioAdf7012::adf_setfecorrection(int valfcorrect);
     //virtual void RadioAdf7012::adf_setfreqnow(unsigned long freq);
     virtual void adf_setfecorrection(int valfcorrect);
     virtual void adf_setfreqnow(unsigned long freq);
     virtual void lock_test(void);
     
  private:
    void send_cmd(const char *cmd, int cmd_len, char *res_adf7012, int res_len);
    void adf_reset_config(void);
    void adf_reset_register_zero(void);
    void adf_reset_register_one(void);
    void adf_reset_register_two(void);
    void adf_reset_register_three(void);
    void adf_write_config(void);
    void adf_write_register_zero(void);
    void adf_write_register_one(void);
    void adf_write_register_two(void);
    void adf_write_register_three(void);
    void adf_write_register(unsigned long data);
    void adf_reset(void);
    int adf_lock(void);
    int adf_locked(void);
    //void lock_test(void);
    void divider_test(void);
    void change(void);  

};
// Register Constants ========================================================

// Register 1 ----------------------------------------------------------------
#define ADF_OUTPUT_DIVIDER_BY_1 0
#define ADF_OUTPUT_DIVIDER_BY_2 1
#define ADF_OUTPUT_DIVIDER_BY_4 2
#define ADF_OUTPUT_DIVIDER_BY_8 3



// Register 1 ----------------------------------------------------------------
#define ADF_PRESCALER_4_5 0
#define ADF_PRESCALER_8_9 1
#define ADF_PRESCALER ADF_PRESCALER_8_9 

// Register 2 ----------------------------------------------------------------
#define ADF_MODULATION_FSK 0
#define ADF_MODULATION_GFSK 1
#define ADF_MODULATION_ASK 2
#define ADF_MODULATION_OOK 3

// Register 3 ----------------------------------------------------------------
#define ADF_CP_CURRENT_0_3 0
#define ADF_CP_CURRENT_0_9 1
#define ADF_CP_CURRENT_1_5 2
#define ADF_CP_CURRENT_2_1 3
#define ADF_MUXOUT_LOGIC_LOW 0
#define ADF_MUXOUT_LOGIC_HIGH 1
#define ADF_MUXOUT_REG_READY 3
#define ADF_MUXOUT_DIGITAL_LOCK 4
#define ADF_MUXOUT_ANALOGUE_LOCK 5
#define ADF_MUXOUT_R_DIVIDER_2 6
#define ADF_MUXOUT_N_DIVIDER_2 7
#define ADF_MUXOUT_RF_R_DIVIDER 8
#define ADF_MUXOUT_DATA_RATE 9
#define ADF_MUXOUT_BATT_2_35 10
#define ADF_MUXOUT_BATT_2_75 11
#define ADF_MUXOUT_BATT_3 12
#define ADF_MUXOUT_BATT_3_25 13
#define ADF_MUXOUT_TEST_MODE 14
#define ADF_MUXOUT_SD_TEST_MODE 15
#define ADF_LD_PRECISION_3_CYCLES 0
#define ADF_LD_PRECISION_5_CYCLES 1

/*
// out SPI 
// out NANO >>>>   via interface MOS 5v-3,3v  quadruple   ebay
// PIN Definitions:
  #define SCKpin  13   // SCK  vers pin 11 clk
  #define SSpin   10   // SS   vers pin 13 LE
  #define MOSIpin 11   // MOSI  vers pin 12 data
// MISO N.U. le adf ne cause pas comme esclave vers Nano maître
*/

#define ADF7012_CRYSTAL_DIVIDER    1    //15    // [1..15]
#define ADF7012_CRYSTAL_FREQ   QUARTZUC8M

#define MAXINDICEMOD 63 // 2p6 -1  reg 2      
#define MAXINDICEPWR 63 // 2p6 -1  reg 2 P1..P6


#endif

// Dominique LEVEQUE F5BEZ 
// =====================================================================
