// ===================================================================
// ====   BALM10beep    générateur UHF , balise  pour manips      ====
// ====   ballon sonde météo M10, pll ADF7012B,GPS Sierra, Nano   ==== 
// ====   version 1.0                   F5BEZ Dominique LEVEQUE   ====
// ===================================================================
//Optimization to reduce memory usage , V1.12    2013-06-09
//Optimization progmem et adaptation aux modules f5bez    14/9/2019 
 
#include "BALM10beep.h"
#include "BALbconfigeepr.h"  

#include <EEPROM.h> 
struct BalStructure
{
  bool balstatus;
  char balcall[7];
  int  correctqrg;
  int  dureebeep;
  int  notebeep;
  int  indicemod;
  int  indicepwr;
  unsigned long baseqrg;
  
};

bool Flagstatus = 0;
int StartEEaddresse = 50; //NBRPARAMS +10; // > à  NBRPARAMS  marge  !

//----------------------------------------------------------
// majuscules
#include <ctype.h>
void strtoupper(char *str)
{
    for ( ; *str ; str++)
        *str = toupper(*str);
}

// -----------------------------------
// lit de eeprom vers Lestatut,MyCall,et autres parametres
bool balreadbconfig(void)
{
  BalStructure balobjet;
  balprintsln("EEp>PAR"); 
  EEPROM.get(StartEEaddresse, balobjet);
  Lestatut = balobjet.balstatus;
  strcpy(MyCall,balobjet.balcall);
  Mycorrectqrg = balobjet.correctqrg;
  Mydureebeep = balobjet.dureebeep;
  Mynotebeep = balobjet.notebeep;
  Myindicemod = balobjet.indicemod;
  Myindicepwr = balobjet.indicepwr;
  Mybaseqrg = balobjet.baseqrg;
  freqbalise[3]    =    Mybaseqrg; 
  sprintf(Buff,"%d %s %d %ld",Lestatut,MyCall,Mycorrectqrg,Mybaseqrg);
  balprinttexteln(Buff);  
  sprintf(Buff,"%d %d %d %d",Mynotebeep,Mydureebeep,Myindicemod,Myindicepwr);
  balprinttexteln(Buff); 
  return (Lestatut);
}

// -----------------------------------
// écrit vers eeprom  Lestatut,MyCall,et autres parametres
void balwritebconfig(void)
{
  BalStructure balobjet;
  balprintsln("PAR>EEp"); 
  balobjet.balstatus = Flagstatus;                // fait 
  strcpy(balobjet.balcall,MyCall);
  balobjet.correctqrg = Mycorrectqrg;
  balobjet.dureebeep = Mydureebeep;
  balobjet.notebeep = Mynotebeep;
  balobjet.indicemod = Myindicemod;
  balobjet.indicepwr = Myindicepwr;
  balobjet.baseqrg = Mybaseqrg; //  +  avec RIT en cours ??
  EEPROM.put(StartEEaddresse, balobjet);
}

// -----------------------------------
// saisie pour MyCall  
// source 0 en ligne  pc   , option  VOIEBT  1   entrée BT  NU  sauf si  Serialbluetooth.xx
void balgetCallindicatif(byte source)
{
  int carlus; 
  balprintsln("call");  // call max 7c  
  balprintsln("F5ZEH"); //   2  fois enter 
  if (source == VOIEPC )
    {
    while (Serial.available () <= 8)   {  }   //   loop  test time out   ou   Serial.setTimeout())
    //carlus = Serial.readBytesUntil(',',MyCall,6); MyCall[carlus] = NUL0;
    carlus = Serial.readBytes(MyCall,6); MyCall[carlus] = NUL0;
    }
  strtoupper(MyCall);         
  balprinttexteln(MyCall);    
/*  NU
               //Serial.flush();  // que tx               
  while (Serial.available () > 0) Serial.read();   // vide Rx
  balprintsln("OK o, RST r"); // 2  fois enter 
  delay(3000); // temps entrer o ou r 
  while(Serial.available() > 0) 
     {
      reponse = Serial.read();    
      switch ( reponse )
      {
      case 'o' :     // oui
         Flagstatus = VRAI;
         balprintsln("Fait"); 
         break;
     case 'r' :     // reset  en fait ce flag à 0 ne chargera pas le call à pwr on, donc call EN DUR du programme
         Flagstatus = FAUX;
         balprintsln("Reset"); 
         break;
      }  
     }  // vide cr lf  

*/
       
}




// -----------------------------------
// saisie pour Note durée  indice modul am   indice pwr 
// source 0 en ligne  pc         option  1   entrée BT  NU  sauf si  Serialbluetooth.xx
void balgetparmodulation(byte source)
{
  balprintsln("note,duree,indam,indpwr");  // note bf   durée note  indice modul am  indice power 
  // balprintsln("expl 1000,500,50,30"); //   2  fois enter 
  if (source == VOIEPC )
    {
    while (Serial.available () <= 14)   {  }   //   loop  test time out   ou   Serial.setTimeout())
     
    Mynotebeep = Serial.parseInt();    // pas ctrl ... 
    Mynotebeep = constrain(Mynotebeep,400,2300);
   
    Mydureebeep = Serial.parseInt();    // pas ctrl ... 
    Mydureebeep = constrain(Mydureebeep,100,900);            // < à 1sec
   
    Myindicemod = Serial.parseInt();    // pas ctrl ... 
    Myindicemod = constrain(Myindicemod,1,63);    
    //Myindicemod = map(Myindicemod,0,100,0,63);            //si saisie 0 à 100% ramenée à max 63  
    
    Myindicepwr = Serial.parseInt();    // pas ctrl ... 
    Myindicepwr = constrain(Myindicepwr,1,63);   
    //Myindicepwr = map(Myindicepwr,0,100,0,63); 

    sprintf(Buff,"%d,%d,%d,%d",Mynotebeep,Mydureebeep,Myindicemod,Myindicepwr);
    balprinttexteln(Buff); 
    }
  //balprintsln("fait"); 
}

// -----------------------------------
// saisie pour correction Frequence 
// source 0 en ligne  pc         option  1   entrée BT  NU  sauf si  Serialbluetooth.xx
void balgetparcorrection(byte source)
{
  balprintsln("correction");  //  registre     du ADF7012
  balprintsln("88"); //   expl  du proto   autour de 90  + - 
  if (source == VOIEPC )
    {
    while (Serial.available () <= 3)   {  }   //   loop  test time out   ou   Serial.setTimeout())
    Mycorrectqrg = Serial.parseInt();    // pas ctrl ... if not fin en 0 3 7    pb   norme ?
    }
  balprinti(Mycorrectqrg); 
  balprintsln("\r\nfait"); 

}


// Dominique LEVEQUE F5BEZ 
// ==============================================================================================================
