// ===================================================================
// ====   BALM10beep    générateur UHF , balise  pour manips      ====
// ====   ballon sonde météo M10, pll ADF7012B,GPS Sierra, Nano   ==== 
// ====   version 1.0                   F5BEZ Dominique LEVEQUE   ====
// ===================================================================

#include "BALM10beep.h"
#include "BALbfonctions.h"
#include "Balbadf7012.h"


#include <EEPROM.h> 

// Prérequit pour les modes bluetooth , entrées analogiques , macros    voir à la fin  de ce fichier

#if defined(FONCTIONSBLUETOOTH) 
 #define GPSBAUDBLUETOOTH 9600     // val par défaut du module  ( changeable code AT .. )
 //#include <SoftwareSerial.h>        // cas 2nd instance prends moins en ram mais pas de saisie bt , que sortie
  //SoftwareSerial Serialbluetooth(INPrxblue,OUTtxblue);
  #include <AltSoftSerial.h>
  AltSoftSerial Serialbluetooth(INPrxblue,OUTtxblue);        // ok  mais met des warning en compilation
#endif  

#define aref_voltage 3.41    
//#define aref_voltage 5.0    // si def interne NANO  ou DEFAULT  
bool flagaddfinligne =  FAUX;
byte parbalisedef[NBRPARAMS];
byte Syscle = 66;        // contrôle 1er byte eeprom  pas 0x00  pas 0xFF  
//bool Flagbt1 = 0;      // les fonctions présets 3 canaux par 3 boutons
//bool Flagbt2 = 0;      // sont invalidées pour gain ram en Nano 
//bool Flagbt3 = 0;
static int etatalarmecycle = 0;
// ---------------------------------------------------------------------------------------------------
// 4  fcts print et println     pour texte fixe et en ptsr   et pour buffer ram
void balprintinfosln(char *string, int valeur)
{
 baltraceinfosln(0,string,valeur);
}
// ----------------
void balprintinfos(char *string, int valeur)
{
 baltraceinfos(0,string,valeur);
}
// ----------------
void balprintinfosbuffln(char *string, int valeur)
{
 baltraceinfosbuffln(0,string,valeur); // faux param N0 trace à 0 sera testée
}
// ----------------
void balprintinfosbuff(char *string, int valeur)
{
 baltraceinfosbuff(0,string,valeur);  // faux param N0 trace à 0 sera testée
}
// ----------------
void baltraceinfosln(int numtrace, const char *string, int valeur)
{
 flagaddfinligne = VRAI;
 baltraceinfos(numtrace,string,valeur);          // 
}
// --------------------------------------------------------------------------------------------------- 
// particularité  methode 1   relecture car par car pour chaine en mémoire flash prog
void stringtobuff(const char *string)
{
 byte aa = 0,cc= 0;  
 Buff[0] = NUL0; //NULL;
      while (0 != ( cc = pgm_read_byte(string++)))
      { 
        Buff[aa++] = (cc);   // if (a > MAXSIZEBUFFER ) NB !!!  pas de test pour gain vitesse
      } 
 Buff[aa] = NUL0; //NULL;
}
/*
// --------------------------------------------------------------------------------------------------- 
// particularité  methode 2   relecture  chaine en mémoire flash prog vers Buff  
// methode 2  _P  https://www.arduino.cc/reference/en/language/variables/utilities/progmem/
void stringtobuff(const char *string)
{
  strcpy_P(Buff,(char *)pgm_read_word(&(string)));  // _P   pose pb  à Buff   instable
}
*/
// --------------------------------------------------------------------------------------------------- 
void baltraceinfos(int numtrace, const char *string, int valeur)
{
 stringtobuff(string);
 baltraceinfosbuff(numtrace,Buff,valeur);
}
// ---------------------------------------------------------------------------------------------------
void baltraceinfosbuffln(int numtrace, char *string, int valeur)
{
 flagaddfinligne = VRAI;
 baltraceinfosbuff(numtrace,string,valeur);
}
// ---------------------------------------------------------------------------------------------------
void baltraceinfosbuff(int numtrace, char *string, int valeur)
{
  if (Sysbalise[S_PTOSERIALUSB]  == VRAI)
    {
    //numtrace = 1; //  forçage   pour pas aff N°
    if (numtrace > 9)        // 0 réservé   1 à 9 réservés
      {
       Serial.print('#'); Serial.print(numtrace); Serial.print(':'); 
      } 
    Serial.print(string); 
    if (valeur > NOVAL)  // NOVAL étant -1  permet afficher la valeur 0
      {
      Serial.print(valeur); 
      }
    if ( flagaddfinligne == VRAI  )
      {
      //    
      Serial.println();
      //Serial.write('\r');  // return ODh
      //Serial.write('\n');  // line-feed OAh  la  paire   carriage return'  'new line' vient des anciennes imprimantes pour retour chariot et avance ligne papier  
      }
    }
  
#ifdef FONCTIONSBLUETOOTH 
  if (Sysbalise[S_PTOBLUETOOTH] == VRAI)
  {
   if (numtrace > 9)        // 0 réservé   1 à 9 réservés
    {
     Serialbluetooth.print('#');  Serialbluetooth.print(numtrace);  Serialbluetooth.print(':');         // si serial1 hard teensy Serial.print('#'); 
    } 
   Serialbluetooth.print(string); 
   if (valeur > NOVAL)  // NOVAL étant -1  permet afficher la valeur 0
    {
     Serialbluetooth.print(valeur); 
    }
   if ( flagaddfinligne == VRAI  )
   {
    //    
    Serialbluetooth.println();
    //Serialbluetooth.write('\r');  // return ODh
    //Serialbluetooth.write('\n');  // line-feed OAh  la  paire   carriage return'  'new line' vient des anciennes imprimantes pour retour chariot et avance ligne papier  
    }
  }  
#endif

flagaddfinligne =  FAUX;  // sert à PC et/ou bluetooth s'il y a  ..\n
}

// ---------------------------------------------------------------------------------------------------
void  balprintcar(char caract)
{
  if (Sysbalise[S_PTOSERIALUSB]  == VRAI)
  {
  Serial.print(caract);
  } 
  
#ifdef FONCTIONSBLUETOOTH 
  if (Sysbalise[S_PTOBLUETOOTH] == VRAI)
  {
   Serialbluetooth.print(caract);
  }  
#endif    
}
// ---------------------------------------------------------------------------------------------------
void  balprintint(int valeur)
{
  if (Sysbalise[S_PTOSERIALUSB]  == VRAI)
  {
  Serial.print(valeur);
  } 
  
#ifdef FONCTIONSBLUETOOTH 
  if (Sysbalise[S_PTOBLUETOOTH] == VRAI)
  {
   Serialbluetooth.print(valeur);
    //  identique mais 
    //Serialbluetooth.print(
    //Serialbluetooth.println(
    //Serialbluetooth.write(
  }  
#endif    
}
//-------------- mise en eeprom des variables Sys de base ou modifiées pour relecture  ------------------------------------------
// set en eeprom les params sys  def  ou modifiés
// NB Si travaux programme : il n'y a pas reset eeprom systématique ???
// NB faire reset 'bt on' au démarrage ou fct 'r' pour enreg. par def. d'abord
void  balwriteparams(void)
{
  byte index = 0;  
  balprintsln("Write EEp");  
  for ( index=0; index < NBRPARAMS; index++) 
    EEPROM.write(index,Parbalise[index]);  
}
//---------------- relit depuis l'eeprom et affecte aux variables Sys  --------------------------------------------------------
// lit val enn eeprom  modifie params par def 
void  balreadparams(void)
{
  byte index=0;  
  balprintsln("Read EEp");
  for ( index=0; index < NBRPARAMS; index++) 
    Parbalise[index] = EEPROM.read(index);
  // balvisuparams();  //  
}  
//---------------- relit paramètres balise par défaut, en service , en eeprom -----------------------------------------------
void  balvisuparams(void)
 {
  char txtparcde[SIZETXTPAR]; 
  byte indexvisu;
  balprintsln("Visu   Param Def  Sys"); 
  for ( indexvisu=1; indexvisu < NBRPARAMSTABLE; indexvisu++) //Parbalise[indexvisu] et EEPROM.read(indexvisu) sont idem
   { 
     if ((indexvisu == 2) || (indexvisu == 4)) continue;  // personnalisation du prg : skip les modes non implantés
     strcpy_P(txtparcde, (char *)pgm_read_word(&(nomsparamstable[indexvisu]))); 
     sprintf(Buff,"N:%02d %s D:%02d S:%02d",indexvisu,txtparcde,parbalisedef[indexvisu],Parbalise[indexvisu]);
     balprinttexteln(Buff);        
   }
 }  

//---------------- help visu aff commandes ------------------------------------
 void  balvisucommandes(void)
 {
  char txtparcde[SIZETXTCDE]; 
  byte indexvisu;
  balprintsln("Aide Modes"); 
  for ( indexvisu=0; indexvisu < NBRCOMMANDS; indexvisu++) 
   { 
   // if ((indexvisu == ) ||  (indexvisu == )) continue;
    strcpy_P(txtparcde, (char *)pgm_read_word(&(nomscommdestable[indexvisu]))); 
    sprintf(Buff,"C: %s",txtparcde);
    balprinttexteln(Buff);        
   }
 }  
 
//---------------- help visu aff commandes  tests   ------------------------
void  balvisucdestests(void)
{ 
  char txtparcde[SIZETXTTST]; 
  byte indexvisu;
 balprintsln("Aide Tests X"); 
  for ( indexvisu=0; indexvisu < NBRTXTTESTS; indexvisu++) 
   {
   //  if ((indexvisu == ) ||  (indexvisu == )) continue;
     strcpy_P(txtparcde, (char *)pgm_read_word(&(nomsteststable[indexvisu]))); 
     sprintf(Buff,"T: %s",txtparcde);
     balprinttexteln(Buff);        
   }
} 
//---------------- surcharge val preset prg paramètres  selon switches  si installés
void  balswitchparams(void)
{
 //  balprintsln("ReadSwitch");  
 //  surcharges par switches ( si implantés  )  
 //  etat = digitalRead(PINsw1);  
 //  Sysbalise[S_ xx] = etat;
 //  digitalWrite(etat    ,ON ou OFF);  // relais pin ant  Tr   // repositionne relais selon states relus par balswitchparams() 
 ;
}
//------------------- logique de démarrage selon le Bt1 et la clé dans l'eeprom  ---------------------------------------------------
// démarrage prg   si bt1 libre avec valeurs params relues, si bt appuyé reset val par def et maj en eeprom   idem  cde  r
// NB NB start  bt  cw   appuyée pour mettre ces val par def en eeprom 
void balstartmodes(void)
{
  byte clevalue=0;
  clevalue  =  digitalRead(BT1CTRL);   // repos 1   appuyé 0
  if (clevalue == KDOWN)  // start reset
  { 
   balsetdefparams();  balwriteparams();  balwritebconfig();  // forçage reset avec val prg
   digitalWrite(LEDVERTE,ON);  // fait relâcher
   while ( digitalRead(BT1CTRL) == KDOWN );
   digitalWrite(LEDVERTE,OFF);
   balprintsln("StartRst"); 
  }
    
  else // non   démarrage normal
  {
  clevalue = EEPROM.read(0);   // lit la 'clé'  à indice 0        // 0 ou 255 après une reprogrammation prg mais pas systématique ?
  balprintln("Cle EEp:",clevalue);                                // la zone eeprom reste  sinon  cde 'r' 
  if (clevalue == Syscle)  
   { balreadparams();   Lestatut = balreadbconfig();   } 
   else
   { balwriteparams();   balwritebconfig();         }   
  }
}

//------------------ modifie une valeur Sys selon l'action ----------------------------------------------------------------------
// modifie la valeur param Sys selon N° action issu télécomm bt1,,Rx Cw  ou cde serial usb PC  et met à jour 
byte balmodifsys(byte action)
 {
  #define SKIPCYCLESMAX    5  // nbre max de cycles tc skip
  #define NBLEVELPOWER     2  // choix base   1  normale du pll à travers , 2  avec le Tr PA , 2 niv  env  13 et 23 dBm   
  #define NBTYPEFREQPWR    3  // 1 NU normal, séquences de pwr   
  #define NBMXFREQCANAUX   4  // 1 2 3 préréglés prg, 4  saisie personnalisation            egalement canaux 1 2 3  par bt
  #define NBMXTYPEMODUL    3  // 0  sans 1 porteuse CW   2 FM   3 AM   //NU 4  AFSK NRZ APRS   
  #define NBMXSEQUENCES    6  // 0  sans  permanent , toutes les 1..5  secondes  , 6 aléa 1..5 
  #define NBTIMEZONE       2  // 0 UTC  1 hiver  2  été 
  #define NBBEEPMIN        4  // 0 sans , 1 même beep que les sec, 2 à 4 pour 5,10,20 sec
  #define NBSCHEDULEMAX    1  // 0 sans 1 avec          n  autres NU ici
  
   switch (action) // A36
    {
     //case 1:  delay(3000); action = 100; break;  // reset décalé 3sec
     case 2:  if (Sysbalise[S_BACTIVE])   { balprintsln("En Balise"); }  else  { balprintln("En Veille",Balpasseveille) }  break;
     case 3:  Sysbalise[S_BACTIVE] = ON;  balprintsln("Balise ON");  Sysbalise[S_BSOMMEIL] = NON;   break;  // 
     case 4:  Sysbalise[S_BACTIVE] = OFF; balprints("Balise OFF");  Balpasseveille = 0;     break;  // set en cycle  balise 
     case 5:  Sysbalise[S_ALARME] = !Sysbalise[S_ALARME]; {balprintln("Alarme:",Sysbalise[S_ALARME]);}   break;
     // inversions  on off flags    ou incréments tournants                 nb  qq modes non utilisés 
    
     case 10:  Parbalise[P_SYNCHRO] = !Parbalise[P_SYNCHRO];  
                           balprintln("Synch:",Parbalise[P_SYNCHRO]);   break;     
     //case 11:  Parbalise[P_SYNCSKIP]++;   {if ( Parbalise[P_SYNCSKIP] > SKIPCYCLESMAX )  Parbalise[P_SYNCSKIP] = 0; // 0 sans 
     //                      balprintln("Skip:",Parbalise[P_SYNCSKIP]);  break;}
     case 12:  Parbalise[P_POWERMODE]++; {if ( Parbalise[P_POWERMODE] > NBLEVELPOWER)  Parbalise[P_POWERMODE] = TXPOWERLOW; 
                           balprintln("Pwr :",Parbalise[P_POWERMODE]);    break;}     
     //case 13:  Parbalise[P_POWERSEQ]++; {if ( Parbalise[P_POWERSEQ] > NBTYPEFREQPWR )  Parbalise[P_POWERSEQ] = 1;     
     //                      balprintln("SeqPwr:",Parbalise[P_POWERSEQ]);   break;}     
     case 14:  Parbalise[P_FREQCANAUX]++; {if ( Parbalise[P_FREQCANAUX] > NBMXFREQCANAUX )  Parbalise[P_FREQCANAUX] = 1; 
                           balprintln("Canal:",Parbalise[P_FREQCANAUX]);  Indexcanaux = Parbalise[P_FREQCANAUX];  break;}   
     case 15:  Parbalise[P_TYPEDEMODUL]++;  {if ( Parbalise[P_TYPEDEMODUL] > NBMXTYPEMODUL )  Parbalise[P_TYPEDEMODUL] = 0;   // 
                           balprintln("Modul:",Parbalise[P_TYPEDEMODUL]);  break;}      //Indexcanaux = Parbalise[P_TYPEDEMODUL];  break;}    
     case 16:  Parbalise[P_BEEPSECONDE]++; {if ( Parbalise[P_BEEPSECONDE] > NBMXSEQUENCES )  Parbalise[P_BEEPSECONDE] = 0;      // 0 sans 
                           balprintln("BeepSec:",Parbalise[P_BEEPSECONDE]);   break;}     
     case 17:  Parbalise[P_BEEPMINUTE]++; {if ( Parbalise[P_BEEPMINUTE] > NBBEEPMIN )  Parbalise[P_BEEPMINUTE] = 0; 
                           balprintln("BeepMin:",Parbalise[P_BEEPMINUTE]);  break;}     
     case 18:  Parbalise[P_MESSINDCW] = !Parbalise[P_MESSINDCW]; 
                           balprintln("IndCw :",Parbalise[P_MESSINDCW]);   break;     
     case 19:  Parbalise[P_HEURELOC]++; {if ( Parbalise[P_HEURELOC] > NBTIMEZONE )  Parbalise[P_HEURELOC] = 0; 
                           balprintln("Utc+n :",Parbalise[P_HEURELOC]);  break;}     
     case 20:  Parbalise[P_FIXEMOBILE] = !Parbalise[P_FIXEMOBILE]; 
                           balprintln("FixeMo:",Parbalise[P_FIXEMOBILE]);  break;     
     case 21:  Parbalise[P_SCHEDULE]++;   {if ( Parbalise[P_SCHEDULE] > NBSCHEDULEMAX )  Parbalise[P_SCHEDULE] = 0; // 0 sans 
                           balprintln("PlanHr:",Parbalise[P_SCHEDULE]);  break;} // schedule planification horaire
                           //to do   oldindexpower = Indexpowe ; oldIndexcanaux = Indexcanaux        mais fin schedule ! faire r reset
     case 25:  Parbalise[P_RELAIS1] = !Parbalise[P_RELAIS1];  
                           balprintln("Relais 1:",Parbalise[P_RELAIS1]);   break;     
     case 26:  Parbalise[P_RELAIS2] = !Parbalise[P_RELAIS2];  
                           balprintln("Relais 2:",Parbalise[P_RELAIS2]);   break;     
      //  29 max                     mode  veille prolongé sur batterie   ;   mode balise qrp sur batterie 
     // autres...
     default:  break;  
    } 

   //NU if (action > 24  && action < 30 )  { balacqreponse(BEEPOK3); Balnumcommande = balfonctionsctrl(action); } // add cf f5zeh
   if (action > 30  && action < 90 )  { balacqreponse(BEEPOK4); Balnumcommande = action; }      //  min max 
   //if (action == 100)  { balsetdefparams();  balwriteparams(); balacqreponse(BEEPOK2);  }  // forçage reset avec val prg
   if (action > 0 && action < 30)   {  balacqreponse(BEEPOK2); Flagpasseaff = VRAI;  }   // A42  I  include : prise en compte ok sauf qui renvoie V ou C
   if (action > 9 && action < 30 )  balwriteparams();             // 10... forçage valeurs Sys dont celles modifiées    sauf 1..9
   Balaction = 0;  // acquitte
   return(0);
 }
   
//----------------------------------------------------
 // en fct du codeaction   fait la fonction      > 30 :  manips sans maj eeprom
 byte balfonctionstests(byte codefonction)
 {
 int test = 0;
 long freqstepadf = FREQSTEPCANAL;
  balprintln("\r\nDebFct:",codefonction);  
  switch (codefonction) 
  {
    case 31:  Parbalise[P_FREQCANAUX] = 1; break; //Flagbt1 = true; break;
    case 32:  Parbalise[P_FREQCANAUX] = 2; break; //Flagbt2 = true; break;
    case 33:  Parbalise[P_FREQCANAUX] = 3; break; //Flagbt3 = true; break;
    case 34:  Parbalise[P_FREQCANAUX] = 4; break;                                       
 
    case 37:  balsynchrogpsclock(NON); break; // 0 que ctrl        //    balafficheDHrtc();  break;
      
    case 39:  balvisuparams(); balprints("Call:"); balprinttexteln(MyCall); test = balreadbconfig();  break; 
  
    case 40:   // H  ?
         balvisucommandes();   //break;
         balvisucdestests(); break;
    case 41:  balenvoieindicatif(); break;
      
    // maintenances et tests  
    
    case 50: balgpsinstall(); break;  // test = baltestsigpsok();  break; // ;  
    case 51:  test = balgpstestraw(OUTGPS0); break; // pc usb  vitesse baud pc
    case 52:  test = balgpstestraw(OUTGPS1); break;  // mode 1  pour émul out nmea et ctrl bluetooth  
    case 53:  test = balgpstestraw(OUTGPS2); break; // mode 2 pour émul out nmea et ctrl bluetooth  continu
    case 54: balmajmanRtc();  break;    // balafficheDHrtc();  break;
    case 55: balsynchrogpsclock(OUI); break;
    case 56: balgetparcorrection(VOIEPC);  balsetcontrolecorrection();  break;    
    case 57: balgetparmodulation(VOIEPC); break; //balwritebconfig();   // 0 pc   (1 bluetooth) nu 
    case 58: balgetCallindicatif(VOIEPC); test = balreadbconfig();  break;      //       //delay(1000);
    case 59: balgetqrgmanip(VOIEPC); Parbalise[P_FREQCANAUX] = 4; Freqshiftadf = 0;  break; // si new qrg  clear shift précédent
    case 60: balgetqrgmanip(VOIEBT); Parbalise[P_FREQCANAUX] = 4; Freqshiftadf = 0;  break;
    case 62: baltestvoiesAD();  break;             //  
    case 63: gettensionsalim(); gettensionoutant(); break;   // //  ctrl V1 V2 //baltestlockpll();  // prov 
    case 64: balmoduleM10(0);  break;      // 0 note des Mn fixée
    case 65: balintrostart(); break;  // 
    case 66: balwritebconfig();  break;   
    case 67: { balsetdefparams();  balwriteparams(); balacqreponse(BEEPOK2);  break;   }  // forçage reset avec val prg
    //case 68: 
    //case 69:      
    // réglages et tests 
    case 70:  Freqshiftadf = Freqshiftadf + freqstepadf;  break;    // +
    case 71:  Freqshiftadf = Freqshiftadf - freqstepadf;  break;   // -     
    case 72:  Myindicepwr++; if ( Myindicepwr >  MAXINDICEPWR )  Myindicepwr = MAXINDICEPWR;  break;     // >   
    case 73:  Myindicepwr--; if ( Myindicepwr <= 0 )  Myindicepwr = 0;  break;   // <    
    case 74:  digitalWrite(ADF7012_TX_DATA_PIN, LOW);  break;    // {
    case 75:  digitalWrite(ADF7012_TX_DATA_PIN, HIGH);  break;   // }    
    case 76:  { Myindicepwr = 1;  break; } //balradioM10.adf_setpwrlevel(1);  break; }       // ]
    case 77:  { Myindicepwr = 63; break; } //balradioM10.adf_setpwrlevel(63);  break; }      // [
    case 78:  { Myindicemod = 1;  break; } //balradioM10.adf_setmodullevel(1); break; }      // (
    case 79:  { Myindicemod = 63; break; } // balradioM10.adf_setmodullevel(63);  break; }     // )  
    //case 76:  { Myindicepwr += 10;  Myindicepwr = constrain(Myindicepwr,1,63); break;  }        //balradioM10.adf_setpwrlevel(1);  break; }       // ]
    //case 77:  { Myindicepwr -= 10;  Myindicepwr = constrain(Myindicepwr,1,63); break; } //balradioM10.adf_setpwrlevel(63);  break; }      // [
    //case 78:  { Myindicemod += 10;  Myindicemod = constrain(Myindicemod,1,63); break; } //balradioM10.adf_setmodullevel(1); break; }      // (
    //case 79:  { Myindicemod -= 10;  Myindicemod = constrain(Myindicemod,1,63); break; } // balradioM10.adf_setmodullevel(63);  break; }     // )     
      
    default:
       break;
      
   } // switch numtest
     balprintln("Fin Test:",test); //codefonction); 
  Flagpasseaff = VRAI;                 
  return (FAUX); // acquitte  à 0
 }
//----------------------------------------------------
void balintrostart(void) 
{
 char bufftit[SIZETXTTIT];
 strcpy_P(bufftit, (char *)pgm_read_word(&(nomsordrestable[0]))); 
 sprintf(Buff,"%s",bufftit);
 balprinttexteln(Buff);  
} 
//----------------------------------------------------
 // selon lettre reçue ( ordre   à 1 lettre ) depuis rx usb-pc ou bt-cw  N° action correspondant 
 // selon x extension et code 1 lettre   depuis pc ou bt          version simplifiée  cf BALf5zeh 
 byte baltelecommandelettre(byte type, char lettre)
 {
byte codeaction = 0;
 switch(type)
 {
  case 0:
   switch (lettre)           // cde à 1 lettre 
   {
     // cde base   retour I nclude    ou   E rreur    pour    codeaction 3..29
 //   case 'R':      { codeaction = 1; break; }     // Reset  chaud  décalé
    case 'T':      { codeaction = 2; break; }     // Test    test comm        Parbalise[P_EN_VEILLE]    retour V ou C
    case 'B':      { codeaction = 3; break; }     // Balise / Beacon          Parbalise[P_EN_VEILLE]
    case 'V':      { codeaction = 4; break; }     // Veille                   Parbalise[P_EN_VEILLE]
    case 'A':      { codeaction = 5; break; }     // Avec ou sans fct alarme 
     // groupe toggle flag Sys ou état   et eeprom
    case 'Y':      { codeaction = 10; break; }     // Parbalise[P_SYNCHRO]    Synchro base NU  à 1
//    case 'K':      { codeaction = 11; break; }     // Parbalise[P_SYNCSKIP]   NU
    case 'P':      { codeaction = 12; break; }     // Parbalise[P_POWERMODE]  Power  pll seul  ou pll et son driver
//    case 'W':      { codeaction = 13; break; }     // Parbalise[P_POWERSEQ]   NU
    case 'Q':      { codeaction = 14; break; }     // Parbalise[P_FREQCANAUX]   Qrg canaux
    case 'M':      { codeaction = 15; break; }     // Parbalise[P_TYPEDEMODUL]   type modul
    case 'S':      { codeaction = 16; break; }     // Parbalise[P_BEEPSECONDE]  Séquence 
    case 'L':      { codeaction = 17; break; }     // Parbalise[P_BEEPMINUTE]   F fixe
    case 'C':      { codeaction = 18; break; }     // Parbalise[P_MESSINDCW]      Cw   
//    case 'U':      { codeaction = 19; break; }     // Parbalise[P_HEURELOC]    Utc 0 , +1 , +2
     case 'F':      { codeaction = 20; break; }     // Parbalise[P_FIXEMOBILE]  Mobile / Fixe   option 
    case 'O':      { codeaction = 21; break; }     // Parbalise[P_SCHEDULE]    schedule planification horaire
       // I     E    courts      non utilisées    A libre
 //   case 'X':      { codeaction = 25; break; }    //  réservé X extensions cde 
 //   case 'Z':      { codeaction = 26; break; }    //  set/reset   relais aux NU
    
    //  groupe cdes 
    case '1':      { codeaction = 31; break; }  // set Fr canal 1  du prg
    case '2':      { codeaction = 32; break; }  // set Fr canal 2  du prg
    case '3':      { codeaction = 33; break; }  // set Fr canal 3  du prg
    case '4':      { codeaction = 34; break; }  // set Fr canal 4  du prg   modifiable 
//   case '5':      { codeaction = 35; break; }
//   case '6':      { codeaction = 36; break; }
//   case '7':      { codeaction = 37; break; }  // 
//   case '8':      { codeaction = 38; break; }
//   case '9':      { codeaction = 39; break; }  // 
    case 'G':      { codeaction = 37; break; }
    case 'N':      { codeaction = 39; break; }
    case 'H':      { codeaction = 40; break; }  // visu Help
    case '?':      { codeaction = 40; break; }  // visu Help
    case 'J':      { codeaction = 41; break; }  // envoie indicatif
    
      // autres... 
     default:       { codeaction = 0; break; }     // rien
   }
   break;
   case 1:
   {
    switch (lettre)             // extended   x et lettre 2 
    {
    // maintenance et tests 
    
    case 'O':      { codeaction = 50; break; }  // gps test install re-init
    case 'D':      { codeaction = 51; break; }  // gps test raw vitesse  PC
    case 'G':      { codeaction = 52; break; }  // gps test raw vitesse  BlueT
    case 'E':      { codeaction = 53; break; }  // gps test raw vitesse  nmea out  en continue
    case 'M':      { codeaction = 54; break; }  // get set qtr manuelle  
    case 'S':      { codeaction = 55; break; }  // set synchro qtr par gps 
    case 'C':      { codeaction = 56; break; }  // get set correction F
    case 'P':      { codeaction = 57; break; }  // get set parametres Freqbf,  Duree , indice mod , indice pwr
    case 'I':      { codeaction = 58; break; }  // get indicatif call
    case 'J':      { codeaction = 59; break; }  // get qrg   par PC    canal 4
    case 'Q':      { codeaction = 60; break; }  // get qrg   par BT    canal 4
    case 'U':      { codeaction = 19; break; }  // forçage  Utc 0 , +1 , +2  // Parbalise[P_HEURELOC] 
    case 'A':      { codeaction = 62; break; }  // ctrl voies A/D   pc  pas bt
    case 'T':      { codeaction = 63; break; }  // ctrl visu tensions et hf
    case 'K':      { codeaction = 64; break; }  // ctrl beep note des Mn
    case 'V':      { codeaction = 65; break; }  // ctrl visu version
    case 'W':      { codeaction = 66; break; }  // set write
    case 'R':      { codeaction = 67; break; }  // reset à def et eeprom
    
     // contrôles  
    case '+':      { codeaction = 70; break; }  // freq +          canal 4
    case '-':      { codeaction = 71; break; }  // freq -
    case '>':      { codeaction = 72; break; }  // pwr +
    case '<':      { codeaction = 73; break; }  // pwr -
  
       //manips dév tests       
    case '{':      { codeaction = 74; break; }  // pin modul 0
    case '}':      { codeaction = 75; break; }  // pin modul 1
    case '[':      { codeaction = 76; break; }  // indice pwr à min 1 
    case ']':      { codeaction = 77; break; }  // indice pwr à max 60 
    case '(':      { codeaction = 78; break; }  // indice modul am  à min 1 
    case ')':      { codeaction = 79; break; }  // indice modul am  à max 60 

      // autres... 
     default:       { codeaction = 0; break; }     // rien
    }
   } // 1
   break;
 } // type  
   
     balprintln("Action:",codeaction); 
     if (codeaction == 0)  balacqreponse(BEEPNOK); // beep erreur
     return(codeaction);  // ou 0 si pas trouvé
 }

//------------- pré définitions des variables Système de l'appli ---------------
// personnalisation selon niveaux matériels en service
void balsetdefparams(void)
{
  byte index=0;  
  Parbalise[P_BAL_CLE]   =  Syscle;   //             repère  eeprom          nb  une partie non utilisée ici mais gardée
  
  Parbalise[P_SYNCHRO]      =   1;    // param  1  Séquence 1 beep std , 2 opt future  autre   cf synchro QTR pour start idem + x secondes ? 
  Parbalise[P_SYNCSKIP]     =   0;    // param  2  NU Séquence 0 sans toutes     n  skip  SKIPCYCLESMAX  fois 
  Parbalise[P_POWERMODE]    =   2;    // param  3  Séquence choix power 1 base pll  'à travers'  ,  2   avec le tr PA
  Parbalise[P_POWERSEQ]     =   1;    // param  4  NU Séquence 1 normale, séquence puissances successives
  Parbalise[P_FREQCANAUX]   =   4;    // param  5  Séquence fréquences uhf   préprogrammées 1,2,3   4 perso saisie
  Parbalise[P_TYPEDEMODUL]  =   1;    // param  6  Séquence 0 sans  1 FM 2 AM, 3 APRS  ,4 ..  options autres 
  Parbalise[P_BEEPSECONDE]  =   1;    // param  7  Séquence 0 non , toutes les n secondes
  Parbalise[P_BEEPMINUTE]   =   1;    // param  8  Séquence 0 sans, 1 beep idem sec, 2..4 beep long minute 5,10,20sec    NBBEEPMIN
  Parbalise[P_MESSINDCW]    =   1;    // param  9  Séquence 0 sans  1 si message cw   
  Parbalise[P_HEURELOC]     =   1;    // param 10  Séquence qtr gps UTC   local  +1  hiver  +2 été       NBTIMEZONE
  Parbalise[P_FIXEMOBILE]   =   0;    // param 11  NU Séquence 0 non fixe,  1 option mobile  avec génération selon position gps  locator, tracking   
  Parbalise[P_SCHEDULE]     =   0;    // parame12  NU Séquence 0 sans macro 1  ..NBSCHEDULEMAX      /batch/schedule/band_happing
  Parbalise[P_RELAIS1]      =   0;    // param 13  NU choix set/reset ou val en cours eeprom gardée 
  Parbalise[P_RELAIS2]      =   0;    // param 14  NU choix set/reset ou val en cours eeprom gardée 

  Sysbalise[S_BACTIVE]      =   OUI; 
  Sysbalise[S_BSOMMEIL]     =   NON; 
  Sysbalise[S_ALARME]       =   NON;
  Sysbalise[S_SIMUL]        =   0;

  Sysbalise[S_PTOSERIALUSB]  = OUI;   // etat    Systeme     mode sortie  'print' vers usb   base standard    0 si que bluetooth  et si redirection Seriel trames gps gga rmc 
  Sysbalise[S_PTOBLUETOOTH]  = OUI;   // etat    Systeme     mode sortie  'print' vers serial bluetooth  en plus de comm usb pc ,  pas en Nano
 
  for ( index=0; index < NBRPARAMS; index++) 
     parbalisedef[index] = Parbalise[index];  // mémo
    
  balprintsln("SetParDef");  
}  

//----------------------------------------------------
// affecte le sens direction  INP ( par défaut )  ou  OUT 
// équivalences PIN voir f5zeh.h    V2.1 Teensy 2   .   Essais réduits en fonctions avec ARDUINO  LEONARDO
void balsetpinsdir(void)
{
 pinMode(LEDROUGE, OUTPUT);
 pinMode(LEDVERTE, OUTPUT);
 //pinMode(BUZZER, OUTPUT); 
 pinMode(PTXGPS, OUTPUT);    // si gps sierra sinon dispo
 digitalWrite(PTXGPS, LOW);  // met 0 
 pinMode(PWRPAPIN, OUTPUT);
 digitalWrite(PWRPAPIN, LOW);  // met 0  cde pa du M10
 pinMode (BT1CTRL, INPUT_PULLUP);
 //pinMode(INPEVEXT, INPUT_PULLUP); 
//pinMode(OUTSAVEPWR, OUTPUT);  
//digitalWrite(OUTSAVEPWR, LOW); // par defaut 0  cad sur le M10 actif pll et gps si HIGH  tr inverseur met off le 3,33v gps et 3,3v pll

//pinMode(INPINT1PPS,INPUT_PULLUP);   // input interruption pour le pulse 1pps front + // ou -
//  attachInterrupt(digitalPinToInterrupt(INPINT1PPS),balsynchro1pps,RISING);  // FALLING
 
 #if defined(FONCTIONSBLUETOOTH) 
   pinMode (INPrxblue,INPUT);
   pinMode (OUTtxblue,OUTPUT); 
 #endif
 
 //!NU  pinMode(PWMREGTEMP, OUTPUT);
 //!NU digitalWrite(PWMREGTEMP, LOW);  // met 0 
}

//----------------------------------------------------
 //  attends commande à 1 lettre et cr lf  ou extension à 2 lettres x et lettre 2  ( cr   lf )  max 4 carac en tout    
byte balreceptioncdepc(void)
 {
  byte numaction = 0;
  byte bytecount = 0;
  char rx[4] = "   ";
  char c;
 if (Sysbalise[S_PTOSERIALUSB]  == VRAI)
 {
  //Serial.setTimeout( ); // def 1s
  while (Serial.available ())    
  {     
   bytecount = Serial.readBytesUntil('\n',rx,4); rx[bytecount] = NUL0;
  }
  //rx[bytecount] = NUL0;
  //Serial.print("bytecount "); Serial.print(bytecount); Serial.print(" >");Serial.print(rx); Serial.print("<");
  if (bytecount == 0)  return(0);
  if  ((rx[0] & 0xDF)  == 'X')  //   x ou X           
   { c = rx[1]; bytecount = 1; } // 0 x  , 1 caract     2 CR  3  LF
  else
   { c = rx[0]; bytecount = 0; } // 0 carac   1 CR  2  LF
  if (( c >= 'a' )   && ( c <= 'z' ))    c = c - 0x20; // toupper case
  balprints("\r\nRxPc:");  if ( bytecount == 1) { balprints("X"); }   balprintc(c);  balprintretourligne;
  numaction = baltelecommandelettre(bytecount,c);  // traite équiv en codeaction
  }  
 return(numaction);
}   

//----------------------------------------------------
// rx  module seriel bluetooth   cde smartphone terminal   idem appli multifonction et domotic  
byte balreceptioncdebt(void)
{ 
#if defined(FONCTIONSBLUETOOTH) 
 byte numaction = 0;
 byte bytecount = 0;
 char rx[4] = "   ";
 char c;
if (Sysbalise[S_PTOBLUETOOTH] == VRAI)
 {
  while (Serialbluetooth.available())  // && (bytecount < 10))  
  {
   bytecount = Serialbluetooth.readBytesUntil('\n',rx,4); rx[bytecount] = NUL0;
  }  
  if (bytecount == 0)  return(0);
  if  ((rx[0] & 0xDF)  == 'X')  //   x ou X   
   { c = rx[1]; bytecount = 1; } // 0 x  , 1 caract     2 CR  3  LF
  else
   { c = rx[0]; bytecount = 0; } // 0 carac   1 CR  2  LF
  if (( c >= 'a' )   && ( c <= 'z' ))    c = c - 0x20; // toupper case
  balprints("\r\nRxBt:"); if ( bytecount == 1) { balprints("X"); }  balprintc(c);  balprintretourligne;
  numaction = baltelecommandelettre(bytecount,c);  // traite équiv en codeaction
  }
 return(numaction);
#endif
}

//----------------------------------------------------
// lit val AD ( tension ) diode out antenne du M10 
void gettensionoutant(void)
{
  int ADReading;
  float voltage1;
  ADReading = analogRead(CTRLATHF);  
  voltage1 = ADReading * aref_voltage;    
  voltage1 = ( voltage1 / 1024.0 )  * 1;  // coeff 1  équiv dbm  vérif au voltmètre
  voltage1 *= 7.8; // coef empirique  mesure dbm  vs lecture diode et son attenuation sur la carte pour U on 50ohms 
 // voltage1 = 20 * log10 ( voltage1); 
 // sprintf(Buff," hf:%2d.%02d V",(int)voltage1, (int)((voltage1 - (int)voltage1) * 100 ));
 //   balprinttexteln(Buff); 
  voltage1 = (20 * log10 ( voltage1))  +13; // ajustage !! que indicatif !!  assez bon de -5 à +23 dBm
  sprintf(Buff," db:% 2d",(int)voltage1);             
  balprinttexteln(Buff); 
}

//----------------------------------------------------
// les tensions 12v et 5v sont relues via R1/R2  et R3/R4 
// pour environ 2,36v au 12v et 2,48 au 5v  soit < aref, et découplées avec 10nF
// version pour BALM10beep    le 12v est gardé si alim externe, le 5v est l'entrée piles en fait   
void gettensionsalim(void)
{
  int ADReading;
  float voltage1,voltage2;
  ADReading = analogRead(CTRL12V);  
  voltage1 = ADReading * aref_voltage;    
  voltage1 = ( voltage1 / 1024.0 )  * 4.51;  // coeff selon les R et vérif au voltmètre
  ADReading = analogRead(CTRL05V);  
  voltage2 = ADReading * aref_voltage ;   
  voltage2 = ( voltage2 / 1024.0 ) * 2.15;                  // pas de %f  en arduino !!
  sprintf(Buff,"Al:%2d.%02d V %d.%02d V  ",(int)voltage1, (int)((voltage1 - (int)voltage1) * 100 ) ,(int)voltage2 , (int)((voltage2 - (int)voltage2) * 100));
  balprinttexteln(Buff); //balprintbuffln(Buff,NOVAL); // avec ln
}

//----------------------------------------------------
// v M10 que led //cde leds  , plus  buzzer visu acquittement ou cde.  , types simplifiés que OK ou NOK
void balacqreponse(int type)
{
 switch (type)
    {
    case BEEPOK1: 
     digitalWrite(LEDVERTE,ON);  delay(1500); digitalWrite(LEDVERTE,OFF);  break;
    case BEEPNOK:
     for (int a = 0;a < 5 ;a++ )
      { digitalWrite(LEDROUGE,ON); delay(140); digitalWrite(LEDROUGE,OFF); delay(60); }
    break;
    }
}

// -----------------------------------------------
// test fin loop  vrai si  'cr' clavier  ou  si  bt down  avec attente retour bt up   'cr'  BT
bool balbtsortirloop(void)
{
 if ( Serial.available()) return(TRUE);
 #if defined(FONCTIONSBLUETOOTH) 
  if ( Serialbluetooth.available()) return(TRUE);
 #endif
 if (digitalRead(BT1CTRL)) return(FALSE);
  else
    do  {  }while( digitalRead(BT1CTRL) == LOW); // NB ! pas test de T.O. 
  delay(100);  
  return(TRUE);  
}

/*
// -----------------------------------------------
// non utilisé ici
void balgetqrgmanip(byte source)
{
 
}
*/
// -----------------------------------------------
// schedule /  planification horaire    simple
// Selon tranche horaire à H pleine, on définit  un canal, ne puissance, un mode , une note ...
// les paramètres de bases en eeprom ne sont pas modifié  et  Parbalise[P_SCHEDULE] actif au démarrage s'il est mis,
// appel  cycle  si (Parbalise[P_SCHEDULE] > 0             // H locale cf qtr  rtc           
// 
void balmodesschedule(void)
{
static byte cgtheure = HeureSch;
if (HeureSch != cgtheure)    // au changement d'heure   
 { 

  balenvoieindicatif(); // version de base   juste  indicatif horaire
    if ( HeureSch == 3 )  {  balsynchrogpsclock(OUI); }  // 
  
  /*
  switch  (Parbalise[P_SCHEDULE])
  {
  case 1:   // 1er groupe horaire
     // exemple  en veille  selon tranche horaire   opt  marche batterie économie !
     // NB NB si Parbalise[P_SCHEDULE] > 0  le mode veille est controlé ici sinon si à 0  retour balise dans la Mn
     if ( HeureSch == 10)    { Sysbalise[S_BACTIVE] = 0;   }  Sysbalise[S_BSOMMEIL] = OUI;  digitalWrite(OUTSAVEPWR,ON);   // exemple tranche arrêt 10h à 12h   
     if ( HeureSch == 12)    { Sysbalise[S_BACTIVE] = 1;  Sysbalise[S_BSOMMEIL] = NON; digitalWrite(OUTSAVEPWR,OFF);  balsynchrogpsclock(OUI); }    // paramétres Indexcanaux Indexpower : ceux actifs
  break;
  case 2:   // 2ème groupe    de 0 à 23h                    //  ligne grise actuellement ( fin oct )  6h30 TU ou 17hTU
     // exemple// Parbalise[P_BEEPSECONDE] = 2; // exemple// Parbalise[P_SYNCSKIP] = 3; // exemple à mettre après Parbalise[P_POWERMODE] 
     // pas switch
     if ( HeureSch == 2 )  { Sysbalise[S_BACTIVE] = 0; }  // exemple à 2h fin  tx  veille  off nuit  
     if ( HeureSch == 3 )  { Sysbalise[S_BACTIVE] = 1; }  // à 3h redémarre 
     if ( HeureSch == 3 )  { if ( balgpstestraw(OUTGPS1) == 2 ) balsynchrogpsclock(1); }  // à  même heure synchro auto qtr par gps si test ok 
     if ( HeureSch == 3 )  { Parbalise[P_FREQCANAUX] = 3;  Parbalise[P_POWERMODE] = 2;  }  //   
     if ( HeureSch == 6 )  { Parbalise[P_FREQCANAUX] = 1;  Parbalise[P_POWERMODE] = 2;  Sysbalise[S_ALARME] = 1;}  //        
     if ( HeureSch == 8 )  { Parbalise[P_FREQCANAUX] = 3;  Parbalise[P_POWERMODE] = 2;  }  //   ...   
     if ( HeureSch == 12)  { Parbalise[P_FREQCANAUX] = 2;  Parbalise[P_POWERMODE] = 1;  }  // 
     if ( HeureSch == 17 )  { Parbalise[P_FREQCANAUX] = 1;  Parbalise[P_POWERMODE] = 2; }  //    
     if ( HeureSch == 19 )  { Parbalise[P_FREQCANAUX] = 2;  Parbalise[P_POWERMODE] = 2; }  // 
   
  break;
  //case 3:  // autres ...  NBSCHEDULEMAX
  } 
  baltraceln(45,"\r\nSched:",HeureSch);
  */
  cgtheure = HeureSch; // fait
 } 
}


//----------------------------------------------------
void balinitbluetooth (void)
{
#if defined(FONCTIONSBLUETOOTH) 
  balprints("\r\nInitBT ");  
  Serialbluetooth.begin(GPSBAUDBLUETOOTH); // baud par defaut HC05/06  sinon en commandes AT+BAUD6 pour 38400
  delay(100);
   //Serialbluetooth.print("AT+VERSION?");   // il ne faut pas que le téléph soit connecté encore 
   //Serialbluetooth.print("AT+NAME?");      // marche pas pour HC06      le HC05 peut être slave ou maître 
  Serialbluetooth.print("AT");              // court   cas 05 
  delay(100);
  balreceptionctxtdebt();  // retour OK   sauf si je téléph est déjà connecté bluetooth avec le HC06
  delay(100); // si déjà connecté
  balprintsln("\r\nDoneBT");  //Serialbluetooth.println("DoneBT");    // direct hors macro et en ram   ln  pour hc05 pas ln pour hc06
#endif
}  

//----------------------------------------------------
void balreceptionctxtdebt(void)
{
#if defined(FONCTIONSBLUETOOTH) 
byte carlus = 0;
  while (Serialbluetooth.available ())    {  }   //   loop  test time out   ou   Serial.setTimeout())
   carlus = Serialbluetooth.readBytes(Buff,20); Buff[carlus] = NUL0;
   if ( carlus == 0 ) sprintf(Buff,"%s","Connect"); // déjà connecté 
  balprinttexteln(Buff); 
#endif   
}  

/*
//----------------------------------------------------
// non implanté ici en Nano modèle  multifonctions   et domotic   teensy 3.2  applis f5bez
//void  balreceptioncenir(void)
//{
//ici reception IR par module IR  et télécommande de TV récup  avec recodage
//des touches en équivalent lettre et codeaction         mais pas pour toutes les fonctions !
// code enlevé pour place ram
//}
*/
// =========================================
// dans le cycle si balgetboutons a vu et armé une requête bt  
void balpresetboutons(void)
{
; // code enlevé
}

// =========================================
// AD6 entrée pour 3 boutons selon méthode échelle de tensions , NB 1 bt à la fois ! // de clockledhp
void balgetboutons(void)
{
;
}

// ---------------------------------------------------
void balinitvoiesAD(void)
{
  byte indexvisu;
  int  valadvoie = 0;
  #define NDEVOIEAD 8   // selon arduino teensy etc
  //analogReference(DEFAULT); // non car repris du 3,3v
  analogReference(EXTERNAL);   // avec le 3,3v comm réf  cela suffit , NB  max entrées AD : 3,3v
  //randomSeed(analogRead(0)); // NU Non Utilisé ici  
  for ( indexvisu = 0; indexvisu < NDEVOIEAD; indexvisu++)    // 4 et 5 réservées 
  {
   valadvoie = analogRead(indexvisu); delay(50);
  }
  valadvoie = valadvoie; //pour no warning 
}

// ---------------------------------------------------
void balgetinfoalarme(void)
{
int  etatADalarme = 0;
int seuil;
#define SEUILADALARME 500
// test  > à  xx   ou <  si pile < 4,2v par exemple  ou bt à 0 avec R vers le 3,3v
// test  photo R  éclairée 12  moyen 100 caché 1270 
  etatADalarme = analogRead(CTRLEVEXT);      // prov  BTSPRESET
  seuil= etatalarmecycle - (etatalarmecycle * 25 / 100 );
   if (( etatADalarme < seuil ) && ( Sysbalise[S_ALARME] == VRAI ))   { Etatalarme = 2; }
   // if ( etatADalarme < SEUILADALARME )   Etatalarme = 2;  //  
   // if ( Flagpulse1pps == VRAI)  {Etatalarme = 1;  Flagpulse1pps = FAUX;}  // méthode interruption acquitte interr
  etatalarmecycle = etatADalarme; 
  if ( Etatalarme > 0 ) { balprintretourligne; baltraceln(24,"Alarme ",Etatalarme); } 

}

// ---------------------------------------------------
void balactionsuralarme(void)
{
/// open  selon ...
 balenvoieindicatif(); // expl 1
 gettensionsalim();    // expl 2  
 //digitalWrite(RELAIS1,ON);  expl 3
}

// =========================================
// maintenance  contrôles valeurs AD brutes     que pc
void baltestvoiesAD(void)
{
byte ntest;  
byte indexvisu;
int  valadvoie = 0;
for ( ntest = 0; ntest < 5; ntest++)
  {
    for ( indexvisu = 0; indexvisu < 8; indexvisu++)    // 4 et 5 réservées 
    {
    valadvoie = analogRead(indexvisu);
    Serial.print("v " ); Serial.print(indexvisu); Serial.print("  " );  Serial.println(valadvoie);
    delay(10);
    }
  delay(1000);
  }
}

// -----------------------------------------------
// source  VOIEPC 0 en ligne  pc  ,  VOIEBT 1  entrée BT
void balgetqrgmanip(byte source)
{
  balprintsln("Get qrg Hz"); 
  if ( source == VOIEPC) 
  {
    while (Serial.available () <= 9)   {  }  //    att !!!  loop  test time out   ou   Serial.setTimeout())
    Mybaseqrg = Serial.parseInt();
    while (Serial.available () > 0) Serial.read();
  }
  #if defined(FONCTIONSBLUETOOTH) 
  if ( source == VOIEBT) 
  {
    while (Serialbluetooth.available () <= 9)   {  }  //    att !!!  loop  test time out   ou   Serialbluetooth.setTimeout())
    Mybaseqrg = Serialbluetooth.parseInt();
    while (Serialbluetooth.available () > 0) Serialbluetooth.read();
  
  }
  #endif
 //Mybaseqrg = constrain(Mybaseqrg,390000000,440000001);
 //if  (( Mybaseqrg  > 400000000 ) && ( FreqTestKey < 410000000)) // ctrl  vraisemblabe
 // {           
  //}
  freqbalise[3] = Mybaseqrg;  Indexcanaux = 4;  Parbalise[P_FREQCANAUX] = Indexcanaux;
  balprintsln("\r\nMAN>QRG");     
  baltraces(44,"FreqM:"); ltoa(Mybaseqrg,Buff,10); balprinttexteln(Buff); 
}


/*
//----------------------------------------------------
// non utilisé ici  NU 
 byte balfonctionsctrl(byte codefonction)
 {
 
 }
//----------------------------------------------------
// non utilisé ici  NU 
void balselectpwrpa(void)
 {

 }
//----------------------------------------------------
// non utilisé ici  NU 
 void balselecttrame(void)     //  init 
 {
 
 }
//----------------------------------------------------
// non utilisé ici  NU 
void balsetpwrrelais(byte codepower)
 {
 
 }
*/
 //---------------bluetooth---------------------------
// Serial est pris pour la liaison usb prg et  monitoring  pc, OU sortie nmea gps pin 1 en autonome USB débranché  
// Serial1 Serial2  ne sont pas disponibles ici , voir Teensy 3. 4.
// SoftwareSerial et AltSoftSerialSoft  sont des drivers de communication série par soft
// 2 instances SoftwareSerial peuvent cohabiter  mais une seule ressource est possible en Rx simultanément
// AltSoftSerial peut cohabiter avec AltSoftSerial ( Uno Nano  At328 family  avec Tx pin 9, Rx Pin 8 )
// SoftSerialsoft devant gérer une vitesse baud haute et AltSoftSeriel une vitesse baud basse, les 2 consomment des ressources ram !
// https://www.arduino.cc/en/Reference/softwareSerial   voir à limitations et la dernière ligne de ce chapitre
// https://www.arduino.cc/en/Tutorial/SoftwareSerialExample  
// https://www.pjrc.com/teensy/td_libs_AltSoftSerial.html        la base 
// https://github.com/PaulStoffregen/AltSoftSerial               plus  
// l'appairage module HC06  et smartphone étant réalisé et testé en préalable 
// le module HC06 est alimenté en 5v direct en amont du pwr on/off du M10   ( option réveil/sommeil par BT )

//-------------analog -----------------------------
// prérequit pour le convertisseur analogique digital interne
// les tensions appliquées sur les entrées analogiques ne doivent pas dépasser le 'aref '  
// connexion  3,3v en fait 3,55v out Nano à  aref via 1,5K de protection  puis mesurer  aref 3,41v variable selon les nano !

// ------------ macros -----------------------------
// fonctions avec macros concernent les sorties  Serialxx.print(ln) 
// les sorties sont aiguillées  soit LCD,  soit PC(usb), soit Bluetooth ( Serialxx )    
// le 1er paramètre est un N° de repère par fonction, par blocs cpp 
// le 2i  paramètre est un texte fixe, il sera inscrit en zone prg  pour gain de ram  ou NOTXT, ou dynamique via ' Buff' 
// le 3i  est une valeur au + int ,  0 permit       ou NOPAR        NB prévoir { }  en appel par macro dans certains cas
// reprise partielle des dév org f5bez dans balf5zeh f1zbx-3 domotic multifonctions 

// ------------ fonctions -----------------------------
// règle des accolades { }  alignées verticalement y compris celles de la fonction
 


// Dominique LEVEQUE F5BEZ 
// ==============================================================================================================
