// ===================================================================
// ====   BALM10beep    générateur UHF , balise  pour manips      ====
// ====   ballon sonde météo M10, pll ADF7012B,GPS Sierra, Nano   ==== 
// ====   version 1.0                   F5BEZ Dominique LEVEQUE   ====
// ===================================================================
#ifndef BALbfonctions_h
#define BALbfonctions_h

// commun aux modules  
#if defined(ARDUINO) && ARDUINO >= 100
 #include "Arduino.h"
#else 
 #include "WProgram.h"
#endif


#define FREQSTEPCANAL 12500  //50000   Hz   pas pour x+ x-  canal 4  NB att à l'arrondi près 8Mhz / 2p15 


// #include <avr/pgmspace.h> pour  PROGMEM de   normallement  Seria.print(F(   n'a pas besoin 

// --------- .h  des modules 



void balprintinfosln(char *string, int valeur);
void balprintinfos(char *string, int valeur);
void balprintinfosbuffln(char *string, int valeur);
void balprintinfosbuff(char *string, int valeur);

void baltraceinfos(int numtrace, const char *string, int valeur);
void baltraceinfosln(int numtrace, const char *string, int valeur);
void baltraceinfosbuff(int numtrace, char *string, int valeur);
void baltraceinfosbuffln(int numtrace, char *string, int valeur);
void balprintcar(char caract);
void balprintint(int valeur);
void stringtobuff(const char *string);

void balintrostart(void); 
void balwriteparams(void);
void balreadparams(void);
void balvisuparams(void);
void balvisucommandes(void);
void balvisucdestests(void); 
void balswitchparams(void);
void balstartmodes(void);
byte balmodifsys(byte action);
//byte balfonctionsctrl(byte codefonction);
//void balsetpwrrelais(byte codepower);
byte balfonctionstests(byte codefonction);
byte baltelecommandelettre(byte type, char lettre);
void balsetdefparams(void);
void balsetpinsdir(void);
//void gettemperature(void);
void gettensionoutant(void);
void gettensionsalim(void);
void ctrltemperature(void);
byte balreceptioncdepc(void);
byte balreceptioncdebt(void);
void balacqreponse(int type);
bool balbtsortirloop(void);
//void balselectpwrpa(void);
void balselecttrame(void);  
void balgetqrgmanip(byte source);
void balmodesschedule(void);
void balinitbluetooth (void);
void balgetboutons(void);
void balpresetboutons(void);
void balinitvoiesAD(void);
void baltestvoiesAD(void);
void balgetinfoalarme(void);
void balactionsuralarme(void);
void balreceptionctxtdebt(void);

extern char Buff[];
extern byte HeureSch; 

extern byte Balaction;
extern int  Balpasseveille;
extern byte Balnumcommande;
extern byte Parbalise[]; 
extern byte Sysbalise[];

extern unsigned long Mybaseqrg;
extern volatile byte Flagpulse1pps;
extern long Freqshiftadf;

extern byte Indexcanaux;
//extern byte Indexpower;
extern bool Lestatut;   
extern char MyCall[];   
extern byte Etatalarme;
extern bool Flagpasseaff; 
extern int  Myindicepwr;
extern int  Myindicemod;

extern  unsigned long freqbalise[];

extern void balsynchro1pps(void);
extern void balenvoieindicatif(void);
extern void balmoduleM10(byte seccycle);
extern void sendTxtestBdes(byte qrgtest); 
extern void balgpsinstall(void);
extern byte balgpstestraw(byte vitesse);
extern byte baltestsigpsok(void);
extern void balsynchrogpsclock(byte mode);
extern int  balafficheDHgps(void);
extern int  balafficheDHrtc(void);
extern void balmajmanRtc(void);

extern void balgetCallindicatif(byte source);
extern void balgetparmodulation(byte source);
extern void balgetparcorrection(byte source);
extern void baltestlockpll(void);
extern void balsetcontrolecorrection(void);
extern bool balreadbconfig(void);
extern void balwritebconfig();
extern void balwriteFlagreset(void);
//extern void setfreq(double f, uint16_t p); 
//extern void sendTxtestKey(void);
 
// textes en segment programme : pour gain en ram
// https://www.arduino.cc/reference/en/language/variables/utilities/progmem/
// global balwfonctions  noms en mem prg   


#define SIZETXTTIT 25
const char  nomtitre1[SIZETXTTIT] PROGMEM = "BALM10beep f5bez V1.0";
//const char  nomtitre2[SIZETXTTIT] PROGMEM = "xxx";
const char *const nomsordrestable[] PROGMEM = \
{ nomtitre1 };  //,nomtitre2};
//{ nomtitre1,nomtitre2};



#define NBRPARAMSTABLE  13 // NBRPARAMS -2
#define SIZETXTPAR 8
const char nompar1[SIZETXTPAR]  PROGMEM = "  CleEE";
const char nompar2[SIZETXTPAR]  PROGMEM = "Y Synch";
const char nompar3[SIZETXTPAR]  PROGMEM = "xxx3   ";
const char nompar4[SIZETXTPAR]  PROGMEM = "P Pwr  ";
const char nompar5[SIZETXTPAR]  PROGMEM = "xxx5   ";
const char nompar6[SIZETXTPAR]  PROGMEM = "M Modul";
const char nompar7[SIZETXTPAR]  PROGMEM = "Q Canal";
const char nompar8[SIZETXTPAR]  PROGMEM = "S BeepS";
const char nompar9[SIZETXTPAR]  PROGMEM = "L BeepM";
const char nompar10[SIZETXTPAR] PROGMEM = "C Indcw";
const char nompar11[SIZETXTPAR] PROGMEM = "U Utc+x";
const char nompar12[SIZETXTPAR] PROGMEM = "F Mobil";
const char nompar13[SIZETXTPAR] PROGMEM = "O PlanH";
//const char nompar14[SIZETXTPAR] PROGMEM = "X Rel 1";
//const char nompar15[SIZETXTPAR] PROGMEM = "Z Rel 2";

const char *const nomsparamstable[] PROGMEM = \
{ nompar1,nompar2,nompar3,nompar4,nompar5,nompar6,nompar7,\
nompar8,nompar9,nompar10,nompar11,nompar12,nompar13 };


#define NBRCOMMANDS 8 //12
#define SIZETXTCDE 14
const char nomcde1[SIZETXTCDE]  PROGMEM = "1 Set Canal 1";
const char nomcde2[SIZETXTCDE]  PROGMEM = "2 Set Canal 2";
const char nomcde3[SIZETXTCDE]  PROGMEM = "3 Set Canal 3";
const char nomcde4[SIZETXTCDE]  PROGMEM = "4 Set Canal 4"; 
//const char nomcde5[SIZETXTCDE]  PROGMEM = "5 Set GPS>QTR";
//const char nomcde6[SIZETXTCDE]  PROGMEM = "6 Get MAN>QTR";
const char nomcde5[SIZETXTCDE]  PROGMEM = "G Aff QTR TIM"; //RTC
const char nomcde6[SIZETXTCDE]  PROGMEM = "J Run indicat";
const char nomcde7[SIZETXTCDE]  PROGMEM = "N Aff Def Sys";
const char nomcde8[SIZETXTCDE]  PROGMEM = "H Aff ?  Help";
//const char nomcde11[SIZETXTCDE] PROGMEM = "R Rst Reset  ";
//const char nomcde12[SIZETXTCDE] PROGMEM = "G Aff version";  // J  N 


const char *const nomscommdestable[] PROGMEM = \
{ nomcde1,nomcde2,nomcde3,nomcde4,nomcde5,nomcde6,\
nomcde7,nomcde8 };


#define NBRTXTTESTS 13
#define SIZETXTTST  28
const char nomtest1[SIZETXTTST]   PROGMEM = "O GPS init    D Aff gps pc "; //27c
const char nomtest2[SIZETXTTST]   PROGMEM = "G Aff gps bt  E Aff gps out";
const char nomtest3[SIZETXTTST]   PROGMEM = "M Set qtr man S Set qtr gps";
const char nomtest4[SIZETXTTST]   PROGMEM = "C Set corr Fq P Set note Pr";
const char nomtest5[SIZETXTTST]   PROGMEM = "J Set qrg  pc Q Set qrg  bt";
const char nomtest6[SIZETXTTST]   PROGMEM = "A Tst A/D 8ch T Aff U-alims";
const char nomtest7[SIZETXTTST]   PROGMEM = "K Tst note Mn I Set indicat";
const char nomtest8[SIZETXTTST]   PROGMEM = "R Reset   def W Write confg";
const char nomtest9[SIZETXTTST]   PROGMEM = "+ qrg stp +   - qrg stp -  ";
const char nomtest10[SIZETXTTST]  PROGMEM = "> pwr pll +   < pwr pll -  ";
const char nomtest11[SIZETXTTST]  PROGMEM = "{ pin mod off } pin mod on ";
const char nomtest12[SIZETXTTST]  PROGMEM = "[ pwr ind +   ] pwr ind -  ";
const char nomtest13[SIZETXTTST]  PROGMEM = "( mod ind +   ) mod ind -  ";

const char *const nomsteststable[] PROGMEM = \
{ nomtest1,nomtest2,nomtest3,nomtest4,nomtest5,nomtest6,nomtest7,nomtest8,\
nomtest9,nomtest10,nomtest11, nomtest12, nomtest13 };

#endif

// Dominique LEVEQUE F5BEZ 
// =====================================================================
