// ===================================================================
// ====   BALM10beep    générateur UHF , balise  pour manips      ====
// ====   ballon sonde météo M10, pll ADF7012B,GPS Sierra, Nano   ==== 
// ====   version 1.0                   F5BEZ Dominique LEVEQUE   ====
// ===================================================================

#include "BALM10beep.h"
#include "BALbgestionbeep.h"
#include "BALbadf7012.h"
#include "BALbmorseTx.h"

static RadioAdf7012  balradioM10;
static BALMorseTx    balmorsetx(1);   
            
// fréquences  de base   type ballon sonde 400M  base du module pll du M10  , du circuit L C , du filtres et du petit PA
// pour monter plus haut voir à pll lock  et bias , ici M10  limite 410Mhz  sinon palier divider par 1  > 410 à 440 ???
// pour 430-440  revoir la micro - self  avec une de moins de uH !!   et le passe-bas du PA
// pour 144 ...  revoir les ' divider ' et les circuits L-C  et la fiche pdf du pll ADF7012 et les exemples
unsigned long freqbalise[4] =   {400000000,401000000,402000000,404000000};      // <<<<<<<<<< personalisation déf canaux 1,2,3,4
//unsigned long freqbalise[4] =   {410000000,390000000,413000000,414000000};      // <<<<<<<<<< personalisation déf canaux 1,2,3,4
//const  int  freqcorrect[3] =  {  -248, -152, -152};  // à froid sans correction temp
//int  freqcoefftemp[3] =  {  0, 0, 0};     // correction en fonction température du xtal 125Mhz du AD9805  voir à régulation
//const int freqshift = 10;     //  NU
//int static freqdecalage = 0;  //  NU
long Freqshiftadf = 0;
unsigned long frequenceaff = 0;  // affichage qrg demandée 
unsigned long frequencenow = 0;  // qrg vers le DDS corrigée
//unsigned long static frequencetest = 400000000;

bool Lestatut  = 0;      // indicateur call :  0  par défaut en dur prg   ou   1 si  personnalisation en eeprom
char MyCall[7] =     { "F5BEZ"} ;     // Callsigns max 6 characters
int  Mydureebeep = 300;   // 300 mS max 1sec
int  Mynotebeep  = 1000;  // Hz   500 à 2000 
int  Myindicemod = MAXINDICEMOD / 2;    // AM   sera fixé en FM                
int  Myindicepwr = MAXINDICEPWR / 2;    // NB cumulatif en AM   pwr et mod
unsigned long Mybaseqrg = FREQUENCEDEFM10;

//----------------------------------------------------
void baladfinstall(void) 
{
   baltracesln(20,"InitADF"); 
// delai sécurité démarrage car l'osc 8Mhz du uC carte M10 doit être démarré
// c'est l'osc ref du adf7012
   delay(200); 
   balradioM10.setup();  // Start radio
   delay(200);
   balradioM10.ptt_on(); // selon le prg org  fait des tests retour MUX si pll est looké
}

//----------------------------------------------------
void balmoduleM10(byte secdcycle) 
{
 int unsigned setduree = 100; 
 int setnote = 1000;
  if     ( secdcycle == 0)   // synchro beep Mn long  // indi 
  { 
    switch ( Parbalise[P_BEEPMINUTE] )
    {
      case 0:   { setduree =   Mydureebeep;  setnote =  Mynotebeep; break;} // 0 note identique chaque sec 0..59
      case 1:   { setduree =   700;  setnote = 1100;  break;}                 // 1 note fixée  longueur < 1sec
      case 2:   { setduree =  5000;  setnote = 1100;  break;}                 // 5 sec 
      case 3:   { setduree = 10000;  setnote = 1100;  break;}   
      case 4:   { setduree = 20000;  setnote = 1100;  break;}   
    }
    if (Parbalise[P_BEEPMINUTE]> 1   )  balprints("M"); // M de beep Minute
  } // beep des Mn fixé
  else   { setduree =   Mydureebeep;  setnote =  Mynotebeep;}
  Indexcanaux = Parbalise[P_FREQCANAUX];

     // f  centrale  fixe  et sa correction  quand  fréq et température  AD9850  ok
     //PROV NU frequencenow = frequenceaff  +   freqcorrect[Indexcanaux-1];       //+ freqcoefftemp[Indexcanaux-1]; 
   if ( Indexcanaux == 4 )  { frequenceaff = freqbalise[Indexcanaux-1] +  Freqshiftadf; } // canal 4 seul avec shift
   else  { frequenceaff = freqbalise[Indexcanaux-1]; }
  frequencenow  =   frequenceaff;  // +  freqcorrect[Indexcanaux-1];  //+ freqcoefftemp[Indexcanaux-1]; 
  //Flagpasseaff = 1; // forçage test à tous les cycles 
  if (Flagpasseaff == VRAI)
  {
  balprintretourligne;   
  baltraceln(21,"Synch:",Parbalise[P_SYNCHRO]);      // que 1   prévu si évolution 
  baltraceln(22,"Canal:",Indexcanaux );  
  baltraces(23,"Freq :"); ltoa(frequenceaff,Buff,10); balprinttexteln(Buff); // ok mais à cause Buff  laisset ltoa après
  baltraces(24,"Modul:");  
    switch (Parbalise[P_TYPEDEMODUL])
     {
     case MODEMODULPORTEUSE: {balprintsln("no"); break;}
     case MODEMODULBEEPCW: {balprintsln("cw"); break;}
     case MODEMODULBEEPFM: {balprintsln("fm"); break;}
     case MODEMODULBEEPAM: {balprintsln("am"); break;}
     }
  if (Parbalise[P_BEEPSECONDE] > 0 )   baltraceln(25,"CodeSec:",Parbalise[P_BEEPSECONDE]);  
  if (Parbalise[P_BEEPMINUTE]  > 0 )   baltraceln(25,"CodeMin:",Parbalise[P_BEEPMINUTE]);
  if (Parbalise[P_BEEPSECONDE] > 0 )
    {
     baltraceln(26,"Note :",Mynotebeep);
     baltraceln(27,"Duree:",Mydureebeep);
    }
 // if ((Parbalise[P_TYPEDEMODUL] == MODEMODULBEEPAM ) || (Parbalise[P_TYPEDEMODUL] == MODEMODULPORTEUSE )) // que AM et porteuse seule 
  baltraceln(28,"Indmod:",Myindicemod);
  baltraceln(29,"Indpwr:",Myindicepwr);
  baltraceln(30,"PowPA :",Parbalise[P_POWERMODE]);
  Flagpasseaff = FAUX; // acquitte affichage param passes      
  } // aff
  else
   balprints("B"); // B de beep sec

/*
  //// essai scan par forçage f 
  frequencetest = frequencetest + 1000000;
  if ( frequencetest > 434000000 )   frequencetest = 400000000;
  frequencenow = frequencetest;
  ////////// 
  */

  sendbeepbalise(frequencenow,setnote,setduree);  // Go ...
}

//----------------------------------------------------
void sendbeepbalise(unsigned long lafreq,int lanote,int unsigned laduree) 
{
  // pour le mode FM   hors config 
  // en theorie doc du pdf 10 fois le step   deviation  NBFM  2,44Kcs
#define  MYINDDEVIATIONFM   10 
int unsigned ndeperiodesnote;
int  demiperiodenote;  // en us
//   approximatif  vs  timing digitalwrite 
ndeperiodesnote = laduree   / ( 1000U / (float)lanote);  // en n de cycles
demiperiodenote = 1000000 / lanote / 2;       // en uS 

//sprintf(Buff,"%d %d %u %d", Mynotebeep,Mydureebeep,ndeperiodesnote ,demiperiodenote        );
//balprinttexteln(Buff);  //ctrl

      //  if (Sysbalise[S_SIMUL]) // test contrôle et dépannage
      // { 
        ;    // code enlevé pour place
      // } 
      //Buff[0] = NUL0;


 switch (Parbalise[P_TYPEDEMODUL] )
  {
   case MODEMODULBEEPFM:
      balradioM10.adf_setmodultype(ADF_MODULATION_FSK);
      break;
   case MODEMODULPORTEUSE:
   case MODEMODULBEEPCW:
   case MODEMODULBEEPAM:
      balradioM10.adf_setmodultype(ADF_MODULATION_ASK);
      break;
  }

  balradioM10.adf_setfreqnow(lafreq); 
  balsettxon(); 
 
  switch (Parbalise[P_TYPEDEMODUL] )
  {
    case MODEMODULPORTEUSE:
     balradioM10.adf_setmodullevel(2);  // arbitraire ne tient pas compte de Myindicemod
     baltrace(31,"\r\npll:",balradioM10.get_powerlevel());     // etat en cours  
     gettensionoutant();     // pour mode porteuse établie   pas pulses
     break;
 
   case MODEMODULBEEPCW:  //---- mod CW 
    balradioM10.adf_setmodullevel(2);  // arbitraire ne tient pas compte de Myindicemod
    delay(laduree);    // pulse porteuse 
    break;
   
   case MODEMODULBEEPFM: //---- mod FM 
    balradioM10.adf_setmodullevel(MYINDDEVIATIONFM);  // en theorie doc du pdf 10 fois le step   deviation  NBFM  2,44Kcs
    balgenenotebf(ndeperiodesnote,demiperiodenote);    
    break;  //---- fin mod FM
     
  case MODEMODULBEEPAM: //---- mod AM 
  // NB NB att PB  en AM les indices de mod et le pwr level sont algébriquement additifs si somme des 2 à max on sature et donc pas de modul
    balradioM10.adf_setpwrlevel(2); // arbitraire ne tient pas compte de Myindicepwr
    balradioM10.adf_setmodullevel(Myindicemod); 
    balgenenotebf(ndeperiodesnote,demiperiodenote);    
    break;  // ------ fin mod AM
 } // switch

 if (Parbalise[P_TYPEDEMODUL] > 0)  balsettxoff(); // en MODEMODULPORTEUSE  porteuse non stop
      
} // fct


// ----------------------------------------
void balgenenotebf(int unsigned fndeperiodesnote, int fdemiperiodenote)
{
int unsigned bclebf;
  for (bclebf = 0; bclebf <fndeperiodesnote; bclebf++)
    {
     digitalWrite(ADF7012_TX_DATA_PIN, LOW); //max
     delayMicroseconds(fdemiperiodenote);
     digitalWrite(ADF7012_TX_DATA_PIN, HIGH);  // 0
     delayMicroseconds(fdemiperiodenote);
    }  
}
// ----------------------------------------
void balsettxon(void)
{
    digitalWrite(LEDROUGE,ON);
    //digitalWrite(ADF7012_TX_DATA_PIN, LOW); 
    balradioM10.adf_setpwrlevel(Myindicepwr);
    balradioM10.adf_setpwretat(ON);
    if (Parbalise[P_POWERMODE] == TXPOWERHIGH )   
      digitalWrite(PWRPAPIN, HIGH);   else  digitalWrite(PWRPAPIN, LOW); 
}
   
// ----------------------------------------   
void balsettxoff(void)
{
    digitalWrite(PWRPAPIN, LOW);  //TXPOWERLOW
    balradioM10.adf_setpwrlevel(0);
    balradioM10.adf_setpwretat(OFF);
    //digitalWrite(ADF7012_TX_DATA_PIN, LOW);
    digitalWrite(LEDROUGE,OFF);
}

// ----------------------------------------   
void baltestlevelhfout(void)
{
  // du chip pll  pas diode out
}

// ----------------------------------------
void balenvoieindicatif(void)
{
  sprintf(Buff,"\n#33 Ind.CW: %s", MyCall );
  balprinttexteln(Buff);  
  balsettxon();
  balmorsetx.balenvoieindicatifcw(VITESSECW,MyCall); 
  balsettxoff();
  delay(300);   // pour blanc l avant prochain beep seconde non collé !!!!
  // pas gênant dans cette manip simple  M10 beep !
}

// ----------------------------------------
void balsetcontrolecorrection(void)
{
  balradioM10.adf_setfecorrection(Mycorrectqrg);
}

// ----------------------------------------
void baltestlockpll(void)
{
   balradioM10.lock_test();
}

// ----------------------------------------
// prévu pour synchro 1 PPS du GPS pour manip plus précise au top 1 sec
// NB la trame nmea avec heure mn et seconde ici  est décalée du traitement Rx env 1 sec. et du 'cycle' prg pas de 100ms
void balsynchro1pps(void)
{
  //Flagpulse1pps = VRAI; // arme flag  
  //digitalWrite(LEDROUGE,ON);   // ou manip spéciale 
} 

// Dominique LEVEQUE F5BEZ 
// ==============================================================================================================
