// ===================================================================
// ====   BALM10beep    générateur UHF , balise  pour manips      ====
// ====   ballon sonde météo M10, pll ADF7012B,GPS Sierra, Nano   ==== 
// ====   version 1.0                   F5BEZ Dominique LEVEQUE   ====
// ===================================================================

// optimisations et adaptations f5bez 2015, 2018  
// version simplifiée pour BALM10beep  pas rtc mais Time soft 

#include  "BALM10beep.h"
#include  "BALbgpstoclock.h"


#include <EEPROM.h> 
#include <TinyGPS++.h>
#include <SoftwareSerial.h>


// prérequit bibliothèques  outils gérer les bibliothèques <mot clé>
// prérequit  voir à BALbfonctions.cpp   et  voir en fin de ce fichier


#define GPSBAUDREADBASE  4800
#define GPSBAUDTXNMEA    4800
#define GPSBAUDREADSIERRA 38400
// 4800   assez std si que GGA et RMC à cadence 1 sec M10 avec trimpble et préprogrammé,  autres (9600) 
// 38400  avec les manips sur le M10 gps  sierra  cdes préalables en MTK
// en version 1 au 24/1  ok ggA et rmc  mais avec des caractères hors ascii binaires  en amont des gga rmc
// voir cde , raw  gps  cependant la fonction synchro reconnaît bien date et qtr de gga et rmc
//// syntaxe normale  #if defined(MA_VARIABLE)   vs ancienne !
#ifdef FONCTIONSGSPSIERRA
 #define GPSBAUDNOW GPSBAUDREADSIERRA    //GPS   voir adaptation M10 par f5bez version sierra reprogrammation in situ à init
#else
 #define GPSBAUDNOW GPSBAUDREADBASE     // //GPS   voir adaptation M10 par f5bez  version trimble reprogrammé avant
#endif
 
 //#define SECS_PER_HOUR (3600UL)  déjà dans time.h
//NU   const int offset = 1;   // Central European Time
//#define TIMEZONE 2 //12 //UTC offset. expl  12,  New Zealand.

//install instances comm 'serialgps'    et fonctions parser 'gps'
SoftwareSerial  serialgps(PRXGPS,PTXGPS); // nécessaire pour Nano   autres hard Serial1 ou 2
TinyGPSPlus     gpsM10;       

// nb  delay(t)  t si > 1 sec  dans bcle rx gps  peut bloquer la bonne Rx gps !   voir exemples full tinygps++
int gpsChkSum, rtcChkSum;

int  Year = 0;        // optimisation  variables en commun
byte Month = 0;
byte Day = 0;
byte Hour = 0;
byte Minute = 0;
byte Second = 0;

 //----------------------------------------------------
void balsynchrogpsclock(byte mode)
// mode 0 controle,  1 active Time
 {
 bool majok = 0;
 byte essais = 1;

 Wire.begin();
 serialgps.begin(GPSBAUDNOW);
 // start ressource gpsM10   si en fonction
 delay(100);
 balprintsln("GPS>QTR");  // gps vers 'time' interne
 do {
    // Every time anything is updated, print everything.
    if ( gpsM10.satellites.isUpdated() )
      {  // pb  fct   !!!! pas fiable 
        baltraceln(40,"N1S:",gpsM10.satellites.value());
      }
    
    baltraceln(41,"Essai:",essais);
    balupdateRTC(mode); // data update. , 0 ctrl  1 update
    baltrace(42,"GPS:",gpsChkSum);  balprintln(" TIM:",rtcChkSum);  //RTC
    if (mode == 0) break;
    if (gpsChkSum == 0) break;  // cas no signal gps
    //if (rtcChkSum == gpsChkSum) 
    if(1)
      {
        majok = 1;
        baltracesln(43,"GPS ok"); 
        flashsetqtrsuccess();  
      }
    else
      {
      baltracesln(44,"Err.CkSum ");
      flashsetqtrfailure();
      delay(2000);
      essais++;
      
      if ( essais > 10 ) 
       {baltracesln(45,"Pb1."); break; } 
      } // pb checksum
 } while (!majok);

  // ajouté clore les ressources gps
   //baltracesln(46,"Ok"); 
   serialgps.end(); 
   Wire.end();
   balprintsln("Fin"); 
  // while (1) {}; //  que si test 

 }

//----------------------------------------------------
void balupdateRTC(byte mode)
{
  unsigned long timer; //Time out. This could actually be annoying.
  int error = 0; // no data counter.
  byte a = 0; // 
  byte timeout = 0;
  bool updated = FAUX; // do, while flag.
  baltracesln(47,"GPS ??"); 
  delay(500); // give the GPS a little time to sort its shit out   < 1sec
  //Do the GPS thing until timeout or success.
  do { 
    while (serialgps.available() > 0) //read GPS data
      gpsM10.encode(serialgps.read());
      //    if both time and date are ready, set the time.   pb :
      //    c'est positif alors que  année  NOK  ou à gps 31/12/1999 ou à rtc 31/12/2095
      //    soit  ctrl année gps  soit reloop à checksum 
    if (gpsM10.time.isUpdated() && gpsM10.date.isUpdated()) 
    {  
      baltraceln(48,"N2S:",gpsM10.satellites.value());
      Year = gpsM10.date.year();  // err org byte
      Month = gpsM10.date.month();
      Day = gpsM10.date.day();
      Hour = gpsM10.time.hour();
      Minute = gpsM10.time.minute();
      Second = gpsM10.time.second();
      setTime(Hour, Minute, Second, Day, Month, Year);
      //balprintsln("UTC"); // aff UTC time du GPS
      gpsChkSum  = balafficheDHgps(0);        //  0  utc    chk utc no used ici
      // set timezone  hiver été   selon la date  added f5bez 
      a =   baltestHetehiver(Day,Month,Year,Hour);  
      baltraceln(49,"TZ +",a); 
      if ( a < 3)    //  ou fixé en dur ! NBTIMEZONE  2 , 0 utc    1 ou 2
      {
      Parbalise[P_HEURELOC]  = a; 
      EEPROM.write(P_HEURELOC,a);  
      } 
      adjustTime(Parbalise[P_HEURELOC] * SECS_PER_HOUR); 
       //Set the RTC avec  QTR time  issu de GPS et H locale.
      if (mode == 1)
      {
        if  ((Year > 2019 ) && ( Year < 2099))    // Year gps  cas 0/0/2000 !!  filtre 
        { 
         // code enlevé pour gain place maj du RTC
          balprintsln("QTR>TIM");  // QTR>RTC   si DS3231  ici Time interne soft en fait ici
        }
       // updated = VRAI; 
      } // else 0 ctrl
        updated = VRAI; 
      //balprintln("LOC +",Parbalise[P_HEURELOC]); 
      gpsChkSum  = balafficheDHgps(1);    // 1 :  H  time loc   depuis UTC// aff qtr gps   même si nok 
      //rtcChkSum = balafficheDHrtc();     //récupère la RTC Time.
    } // de  time and date are ready
    else 
    {  // T et D not ready !!
      if (gpsM10.charsProcessed() < 20) 
      {
        baltracesln(50,"Flux?"); 
        if (error > 10) 
        {
          baltracesln(51,"flux pb"); // gps ne reçoit pas 
          error = 0;
          delay(1000);
          break;  // added
        }
        error++;
        baltraceln(52,"GPS data ",error); 
        delay(500);
        
      } // gps  pas assez de carc ou rien 
      else 
      {  //  des carc   mais pb   ça  n'aboutit pas ???
        if (a == 0) 
        {
          baltracesln(53,"GPS vu"); 
          timer = millis();
        }
      
        a++;
        if (a > 15) // trop d'essais pb
        {
          a = 1;
          digitalWrite(LEDROUGE, !digitalRead(LEDROUGE)); // add
        }
        if (millis() - timer > 20000) 
         {
          baltracesln(54,"\r\nT.Out"); 
          flashsetqtrfailure();
          timeout++;
          /// si pb  force sortie  // pas de qtr gps  force relance test synchro + 3mn
          if (timeout > 20) { updated = 1;  balpresettime();  } 
         } 
      } // de  gps  vu  et procÃ¨de 
    } // time and date are  NOT  ready

    if (balbtsortirloop()) break;
  }  // du  DO  on recommence 
  while (!updated);

} // fct


// ------------------------------
byte decToBcd(byte val)
{
  return ( (val / 10 * 16) + (val % 10) );
}

// -------------------
// Convert binary coded decimal to normal decimal numbers
byte bcdToDec(byte val)
{
  return ( (val / 16 * 10) + (val % 16) );
}
//----------------------------------------------------
//Get time from RTC      si installé
/*
void readDS3231time(byte * second,
                    byte * minute,
                    byte * hour,
                    byte * dayOfWeek,
                    byte * dayOfMonth,
                    byte * month,
                    byte * year)      // le chip est byte  year 

{
  Wire.beginTransmission(DS3231_I2C_ADDRESS); 
  //etc
}
*/
//----------------------------------------------------
// optimisation  en commun
void  printjoursemaine(byte joursem)
{
 switch (joursem) 
     {
       case 1: balprintsln("Dimanche");  break;           
       case 2: balprintsln("Lundi");  break;  
       case 3: balprintsln("Mardi");  break;  
       case 4: balprintsln("Mercredi");  break;  
       case 5: balprintsln("Jeudi");  break;  
       case 6: balprintsln("Vendredi");  break;  
       case 7: balprintsln("Samedi");  break;  
      }
}

// ------------------------------------------------------------------
int balafficheDHgps(byte typeqtr)
{
int checksumgps = 0;
char chqtr[4] = "   ";
  if (typeqtr == 0)   sprintf(chqtr,"%s","UTC");  else   sprintf(chqtr,"%s","LOC");
  sprintf(Buff,"%s %02d:%02d:%02d %02d/%02d/%02d %d ",chqtr,hour(),minute(),second(),day(),month(),year(),weekday());
  balprintbuff(Buff,NOVAL);
  printjoursemaine(weekday());
  checksumgps = second() + minute() + hour() + weekday() + day() + month() + year() - 2000;     
  return(checksumgps);
}
// ------------------------------------------------------------------
int balafficheDHrtc(void)
{
; // code enlevé pour place et pas de chip rtc ici
return(0);
}


// ------------------------------------------------------------------
// NB  non prévu en saisie pour inp  en  bluetooth 
// NB H pc si time synchro juste   ou  avec une horloge synchro radio (dcf77)
void balmajmanRtc(void)
{
  balprintsln("H loc; yyyy,m,d,h,m,s"); 
  balprintsln("'enter' au top sec 59"); 
  balprintsln("ex:2020,10,15,16,33,00");       
  while (Serial.available () <= 19)   {  }  // ex 12   att !!!  loop  test time out   ou   Serial.setTimeout())
  Year = Serial.parseInt();
  Month = Serial.parseInt();
  Day = Serial.parseInt();
  Hour = Serial.parseInt();
  Minute = Serial.parseInt();
  Second = Serial.parseInt();
  setTime(Hour, Minute, Second, Day, Month, Year);
  adjustTime(0);   // set H saisie locale 
      //adjustTime(TIMEZONE * SECS_PER_HOUR); //Set time to current timezone
      //Set the RTC avec date heure saisie.
      // code enlevé pour place
    balprintsln("\r\nMAN>TIM");  // RTC
    while (Serial.available () > 0) Serial.read();
    delay(100);
    //Year =  balafficheDHrtc(); // ici Year pour int vide  
}

// ------------------------------------------------------------------
// raw  'trames brutes '   test en usb pc  ou redirection trames gps Serial  pin  1  si vitesse 1  sinon 0 usb base
//   retour 0  pas de Rx gps : câblage, alimentation DC 5v, 
//   retour 1  caractères non conformes, format 4800,8N2 ? , niveau ttl , driver 
//   retour 2  trame vue au moins 1 $ vu , mais non certifiée trame peut être incomplète ?
//   vitesse 0  out base pc usb  VITBAUDUSB ,  1  idem mais GPSBAUDTXNMEA   et bluetooth ,    2 idem en continue                
byte balgpstestraw(byte vitesse)
{
#define MAXBCLETEST  5           // durée du test   en sec ( 0 et 1 )
byte caract;
bool isbt;
bool  flagdollarvu = 0;   //>>nb v 0.9 sierra filtrage caracteres bin ou non baud garde que de $ à cr/lf 
unsigned long tempstart = millis();
byte statutrxgps = STATUTRXGPS0;
   serialgps.begin(GPSBAUDNOW);
   balprintsln("GPSrawDeb");  
   isbt = Sysbalise[S_PTOBLUETOOTH];
   if (vitesse == OUTGPS0 ) {  Sysbalise[S_PTOBLUETOOTH]  = NON; }  // si test out nmea vitesse 1 ou 2  pas out pc  car vitesse 1 
   if (vitesse > OUTGPS0 ) {  Sysbalise[S_PTOSERIALUSB]  = NON;   Serial.begin(GPSBAUDTXNMEA); }    // 1 et 2  out pin 1   et BT même vitesse
   delay(50);
 while(1)
 {   
  if (serialgps.available()) 
  {
    caract = serialgps.read();  ///// lit le flux brut 1 à 1
    if (statutrxgps == STATUTRXGPS0 ) statutrxgps = STATUTRXGPS1; // des caractères sont reçus
    if ( caract == LF )  { balprintc(LF);    flagdollarvu = FAUX; }    // fin utile  balprintretourligne  
    if ( caract == '$' ) flagdollarvu = VRAI; // début utile 
    if  ((statutrxgps == STATUTRXGPS1 ) && ( flagdollarvu == VRAI )) statutrxgps = STATUTRXGPS2;  // on a vu un $ !
    if (flagdollarvu ) balprintc(caract); // sur le pc en monitoring si VITBAUDUSB non mettre GPSBAUDTXNMEA
  }
 
  // fin visu par  key enter  = exit  ou  temps limité   ou  mode 2  en continu 
  if (  (balbtsortirloop()) ||  (  (   (vitesse < OUTGPS2) && ( millis() - tempstart ) >= MAXBCLETEST * 1000 )  )  )
  {
    serialgps.end();  // clôt la ressource
    Serial.begin(VITBAUDUSB); // remet
    Sysbalise[S_PTOSERIALUSB]  = OUI;   //  
    Sysbalise[S_PTOBLUETOOTH] =  isbt;  // remet s'il l'était
    balprintsln("GPSrawFin");    
    return(statutrxgps);
  }
 }
}
/*
// https://fr.wikipedia.org/wiki/NMEA_0183
// simulation sortie à vistesse PC   mode defined sans bluetootooth  pour réduire les ressources
// si la vitesse est GPSBAUDTXNMEA et sortie pin 1  : sortie gps nmea pour toutes applis
GPSrawDeb
$GPGGA,153415.000,48xx.7339,N,001xx.0314,W,1,4,3.61,42.3,M,48.2,M,,*70
$GPRMC,153415.000,A,48xx.7339,N,001xx.0314,W,1.53,260.30,150220,,,A*7D
$GPGGA,153416.000,48xx.7339,N,001xx.0303,W,1,5,2.02,39.4,M,48.2,M,,*7B
$GPRMC,153416.000,A,48xx.7339,N,001xx.0303,W,1.59,260.30,150220,,,A*72
$GPGGA,153417.000,48xx.7344,N,001xx.0288,W,1,5,2.02,36.1,M,48.2,M,,*78
$GPRMC,153417.000,A,48xx.7344,N,001xx.0288,W,1.59,260.30,150220,,,A*7B
$GPGGA,153418.000,48xx.7351,N,001xx.0290,W,1,5,2.02,39.2,M,48.2,M,,*76
$GPRMC,153418.000,A,48xx.7351,N,001xx.0290,W,1.57,260.30,150220,,,A*77
$GPGGA,153419.000,48xx.7367,N,001xx.0291,W,1,5,2.02,46.3,M,48.2,M,,*7A
$GPRMC,153419.000,A,48xx.7367,N,001xx.0291,W,0.96,260.3,50220,A*E
GPSrawFin
Fin Test:2
 48B 49B

 * 
 * exemples  raw  $ début GP  RMC  et GGA,
 * heure TU 9h41,ok,latitude,longitude,vitesse sol,cap,date 15 oct 2019,déclinaison magnétique,*checksum<cr/lf>
$GPRMC,094110.00,A,48xx.001xx,N,001xx.00896,W,000.0,000.0,151019,01.6,W,A*00
 * heure TU 9h41,latitude,longitude,Fix gps,3 satellites,dop,altitude 59m,correction,vide,vide,*checksum<cr/lf>
$GPGGA,094111.00,48xx.001xx,N,001xx.00896,W,1,03,3.11,00059,M,048,M,,*7D
$GPRMC,094111.00,A,48xx.001xx,N,001xx.00896,W,000.0,000.0,151019,01.6,W,A*01
$GPGGA,094112.00,48xx.001xx,N,001xx.00896,W,1,03,3.11,00059,M,048,M,,*7E

GPSrawDeb  exemple trame non 'FIXée '  attente la position est celle en mémoire , pas d'heure ni date
$GPGGA,,48xx.73954,N,001xx.99096,W,7,00,,,,,,,*42
$GPRMC,,V,48
$GPGGA,,48xx.00954,N,001xx.00096,W,7,00,,,,,,,*42
$GPRMC,,V,48xx.00954,N,001xx.00096,W,,,,,,M*73
$GPGGA,,48xx.00954,N,001xx.00096,W,7,00,,,,,,,*42
$GPRMC,,V,48xx.00954,N,001xx.00096,W,,,,,,M*73

GPSrawDeb  exemple pb  caractères reçus mais non conformes
JK⸮IK⸮)x+(;,JjKI*,KJijJ⸮IZzYzj⸮IJIIJIIZZ*
*/
// --------------------------------------------------------------------------------
byte baltestsigpsok(void)
{
  // enleve
  return(FAUX);
}
// --------------------------------------------------------------------------------
// #912 détermine si la date-heure est H été ou H hiver 
// le passage à l'heure d'été intervient le dernier dimanche de mars à 2 heures du matin 
// et le passage à l'heure d'hiver intervient le dernier dimanche d'octobre à 3 heures du matin.
// inp : jj mm aa hh     out : 1  hiver  2  été          cf f5bez
byte baltestHetehiver(byte jour,byte mois,byte an, byte heure)  
{
byte avant, apres;
byte joursem;
//int annee;
//annee = 2000 + an;   // format yyyy
//  if( annee < 1976 ) return 1;    // non applicable ici
  if ( an < 19 ) an = 19;  // just warning skip
  if( mois < 3 ) return (1);
  if( mois > 10 ) return (1);
  if( (mois > 3) && (mois < 10 )) return (2);   
  // dans mois 3 ou 10
  if( mois == 3 ) { avant = 1; apres = 2; }
  else { avant = 2; apres = 1; }
  if( jour < 25 ) return avant;  // test après le 25 
  //joursem = balretjoursem(jour,mois,annee); // cherche j demaine 0 = dimanche à samedi 6
  joursem = weekday()  -1; 
  if( joursem == 0 ) return heure > 1 ? apres : avant;  // ambiguité ici entre 2H et 3 H en octobre
  return (31 - jour + joursem) >= 7 ? avant : apres;
}

//----------------------------------------------------
void flashsetqtrfailure()
{
   balacqreponse(BEEPNOK);
}
//----------------------------------------------------
void   flashsetqtrsuccess()
{
   balacqreponse(BEEPOK1);
}

//======================================================================================================================================
// module M10 GPS copernik ( grand carré ) non applicable ici , se fait à part avec Trimble  et mode nmea conservé en flash interne
// module M10 GPS Sierra     ( petit carré )  injection paramétres init pour mode nmea  tant que pas trouvé la mémo flash !   microcode !!
//https://www.sparkfun.com/datasheets/GPS/Modules/PMTK_Protocol.pdf
//https://cdn-shop.adafruit.com/datasheets/PMTK_A11.pdf
// NB NB l'ordre des commandes MTK n'est pas déterminé  , la cde 341 est envoyée en 4 fois pour gain place ram 
void balgpsinstall(void)
{
 #if defined (FONCTIONSGSPSIERRA) 
 byte pt;
 baltracesln(57,"GPSinit"); 
 // serialgps.begin(VITBAUDUSB); readstring(); while (1); // manip test pour ctrl si gps envoi qq chose à power on  avant init : NON !
 serialgps.begin(GPSBAUDNOW); 
 for ( pt = 0; pt < NBRECDEMTK ;pt++)  balenvoiecdemtk2(pt); // 8 cmd en 11 trames
 baltracesln(58,"\r\nGPSdone"); 
 serialgps.end(); 

  // manip test pour régénérer la checksum  si pas mise en dur  pour gain place en ram ...
  //char mytrame[] = "PMTK314,0,1,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0";    // chk 28 hex                
  //int chk = nmeachecksum(mytrame);
  //Serial.print("Trame: $"); Serial.print(mytrame); Serial.print("*"); Serial.println(chk,HEX);      //Trame: $PMTK314,0,1,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0*28

#endif
}
// retour en l'état V0.9 init filtré des caracs non alphanum
//#24:GPSinit
//CjxVQCLHXPMTK705AXN51133331708170085aC2ybxVYLXiAPMTK001314336CIj8fYKLXIAPMTK001301332Biz8fQKLHPMTK001330330p6
//#24:GPSdone

          //*cdemtk)

//----------------------------------------------------  
// NB la cde 341 est envoyée en 4 fois pour gain place ram 
void balenvoiecdemtk2(byte numcd)
{
#if defined (FONCTIONSGSPSIERRA) 
   if  ((numcd != 4)  && (numcd != 5)  && (numcd != 6))     // pas d'en-tete 
    {
    sprintf(Buff,"%s","$PMTK");    //  en-tête générique   
    sendstring(Buff); 
    baltransfertcmd(numcd);
    sendstring(Buff);
     if  (numcd != 3)     // cr lf sauf la 1ere partie de la 314
     {
    sprintf(Buff,"%s","\r\n");    //  fin
    sendstring(Buff); 
     }
   
    
    serialgps.begin(GPSBAUDREADSIERRA);   // afin de relire recup caracteres étranges et le message de retour !!!<<<<<<<<<<<
    readstring();    ///// NB NB il faut read pour no lock tx ?
    delay(100);
    serialgps.begin(GPSBAUDNOW);  // remet <<<<<
    }
    else          
    {
    baltransfertcmd(numcd);
    sendstring(Buff);
    if  (numcd == 6)       // cr lf de la dernière partie de la 314
     {
    sprintf(Buff,"%s","\r\n");    //  fin
    sendstring(Buff); 
     }
    }
  delay(100);
#endif
}

//----------------------------------------------------
void baltransfertcmd(byte numcmd) 
{
 char buffcmd[SIZETXTCMDMTK]; // < à Buff
 strcpy_P(buffcmd, (char *)pgm_read_word(&(nomscdemtktable[numcmd]))); 
 sprintf(Buff,"%s",buffcmd);
} 

//----------------------------------------------------  
 void sendstring(char trame[]) 
 {
    serialgps.print(trame);   // 
    //Serial.print(trame);  // test debug
 }

//----------------------------------------------------   
void readstring (void)
 { 
 char cg =0;
 while (serialgps.available()>0)
   {
    // V 0.9 où les caracteres reçus ont diff vitesses baud ou des ctrl non connus ou des 'bouts' binaire non documentés ou non connus à ce moment
     cg = serialgps.read();  if (isAlphaNumeric(cg)) Serial.write(cg); // filtre   garde que AZ 09  pas de cr lf 
     //Serial.write(serialgps.read()); // sans filtre
   }
 }
 
//----------------------------------------------------   
//https://en.wikipedia.org/wiki/NMEA_0183
//The checksum at the end of each sentence is the XOR of all of the bytes in the sentence, excluding the initial dollar sign. 
int nmeachecksum(const char *trame) 
{
    int cks = BUG;
    while (*trame)
        cks ^= *trame++;        // cumul bytes en XOR le signe ' ^ ' 
    return cks;
}
// ================================================================
// références
//-----------------------------------------------------------------
// 15/8/2019 F5BEZ clockgpsDS5 avec ctrls  ok             
// https://gist.github.com/Makeshit/0f230ed88df65dfaf43f
// https://tronixstuff.com/2014/12/01/tutorial-using-ds1307-and-ds3231-real-time-clock-modules-with-arduino/      // cf  UNO   d4 d5    !!
// 
// https://www.arduino.cc/en/Reference/softwareSerial   voir à limitations et la dernière ligne de ce chapitre
// SoftwareSerial serialgps(PRXGPS,PTXGPS); // nécessaire pour Nano   autres hard Serial1 ou 2
// https://www.pjrc.com/teensy/td_libs_TinyGPS.html  N'EST PAS utilisée 
// prérequit croquis inclure une bibliothèque   ajouter la bibliothèque zip
// prérequit  PJRC  Teensy   http://arduiniana.org/libraries/tinygpsplus/        
// TinyGPSPlus gps;       
// thanks bibli  TinyGPS++  PJRC 
// Others Credits:
// RTC I2C code is mostly lifed from tronixstuff :
// http://tronixstuff.com/2014/12/01/tutorial-using-ds1307-and-ds3231-real-time-clock-modules-with-arduino/
// Some of the GPS code is pasted from the TinyGPS tutorials.
// https://github.com/mikalhart/TinyGPSPlus/releases
// Thank you both.
// By Makeshit http://tastyfrogs.blogspot.co.nz/
// ================================================================
// fct   annexe Parbalise[P_FIXEMOBILE]    'en mobile'    nav  pt 1   vers pt 2 distance azimut ...
//void balgetpositionendec(void)  // cf f5bez  et lib  tinygps++   à partir de GGA RMC
//void balpositionalocator(void)  // cf f5bez  
// NB Un peu d'histoire : .. "position" en degrés  décimaux long. lat.   vers locator :
// NB f1bez : en fortran en 1975 sur  pdp11-O5  puis en Digital-basic sur pdp11-73   !!  
// NB ancien locator, distance, azimut, retranscrit selon formulaire de navigation marine d'orthodromie.  
// NB puis en nouveau locator fait en ass.Intel8085, puis en turbo-basic, puis en c au fil des réalisations 
// NB avec gps garmin 2++ à ses débuts !! Visu sur un petit notebook LCD N&B 'Tandy' MSDOS et cartes marines Shom scannées
// NB Mes 1er tracés ' gps '  en sortie voile St-Quay-Portrieux  Jersey ,  puis Pornichet,  îles du ponan ...
// ==============================================================================================================

// Dominique LEVEQUE F5BEZ 
// ==============================================================================================================
  
