// ===================================================================
// ====   BALM10beep    générateur UHF , balise  pour manips      ====
// ====   ballon sonde météo M10, pll ADF7012B,GPS Sierra, Nano   ==== 
// ====   version 1.0                   F5BEZ Dominique LEVEQUE   ====
// ===================================================================

#ifndef BALbgpstoclock_h
#define BALbgpstoclock_h

// commun aux modules  
#if defined(ARDUINO) && ARDUINO >= 100
 #include "Arduino.h"
#else 
 #include "WProgram.h"
#endif


#include "BALbfonctions.h"

byte get2sec(void);

void balsynchrogpsclock(byte mode);
byte decToBcd(byte val);
byte bcdToDec(byte val);
void readDS3231time(byte * second,
                    byte * minute,
                    byte * hour,
                    byte * dayOfWeek,
                    byte * dayOfMonth,
                    byte * month,
                    byte * year);
                    
void balupdateRTC(byte mode);

void  printjoursemaine(byte joursm);
void flashsetqtrfailure();
void flashsetqtrsuccess();
int  balafficheDHgps(byte typeqtr);
int  balafficheDHrtc(void);
void balmajRtc(void);
byte balgpstestraw(byte vitesse);

byte baltestHetehiver(byte jour,byte mois,byte an, byte heure);  

void balgpsinstall(void);
//void balenvoiecdemtk(const char cdemtk[]);
void balenvoiecdemtk2(byte numcd);
void balreadcmd(byte numcd);
void sendstring(char trame[]);

void baltransfertcmd(byte numcmd); 


void readstring (void);
int nmeachecksum(const char *trame);

extern byte Parbalise[]; 
extern byte Statutrxgps;
extern char Buff[];
extern void balpresettime(void);

// textes en segment programme : pour gain en ram

#define NBRECDEMTK  11
#define SIZETXTCMDMTK 13  // la plus longue    n c  +1
                                                                // l'ordre des commandes n'est pas très clair   là  en  v0.9  ça marche
const char  nomtcdemtk000[SIZETXTCMDMTK]   PROGMEM = "000*32"; //retour: $PMTK001,0,3*30       //devrait retour correct 38400 bds  ensuite retour à 4800bds sauf nmea
const char  nomtcdemtk605[SIZETXTCMDMTK]   PROGMEM = "605*31"; // réf   //    cf  balinfos macro  ou  sprintf(Buff,""%s%s",ttpmtk,"605*31"");
const char  nomtcdemtk183[SIZETXTCMDMTK]   PROGMEM = "183*38"; //  status                                       //   gain ram                        char ttpmtk[6]=  "$PMTK";
const char  nomtcdemtk314A[SIZETXTCMDMTK]  PROGMEM = "314,0,1,0,1";         // division en 4 blocs  pour optimiser buffer ram   Buff
const char  nomtcdemtk314B[SIZETXTCMDMTK]  PROGMEM = ",0,0,0,0,0,0";  //   $PMTK314,0,1,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0*28 
const char  nomtcdemtk314C[SIZETXTCMDMTK]  PROGMEM = ",0,0,0,0,0,0"; 
const char  nomtcdemtk314D[SIZETXTCMDMTK]  PROGMEM = ",0,0,0*28"; // 
const char  nomtcdemtk301[SIZETXTCMDMTK]   PROGMEM = "301,0*2C";     // set dgps off          // le pb  est-ce en mémoire ou à remettre à chaque fois !!
const char  nomtcdemtk330[SIZETXTCMDMTK]   PROGMEM = "330,0*2E";     // set datum  def 0 = WGS84
const char  nomtcdemtk220[SIZETXTCMDMTK]   PROGMEM = "220,1000*1F";  // set pos fix interval  1sec
const char  nomtcdemtk251[SIZETXTCMDMTK]   PROGMEM = "251,38400*27"; // pour nmea
//const char  nomtcdemtk101[SIZETXTCMDMTK] PROGMEM = "101*32";  // start hot warm     pas clair

const char *const nomscdemtktable[] PROGMEM = \
{ nomtcdemtk000,nomtcdemtk605,nomtcdemtk183,nomtcdemtk314A,nomtcdemtk314B,nomtcdemtk314C,nomtcdemtk314D,\
  nomtcdemtk301,nomtcdemtk330,nomtcdemtk220,nomtcdemtk251 };  

#endif

// Dominique LEVEQUE F5BEZ 
// =====================================================================
