// ===================================================================
// ====   BALM10beep    générateur UHF , balise  pour manips      ====
// ====   ballon sonde météo M10, pll ADF7012B,GPS Sierra, Nano   ==== 
// ====   version 1.0                   F5BEZ Dominique LEVEQUE   ====
// ===================================================================
//
// Usage:
//       BALMorseTx <handlebalmorsetx>(<inputpin>,<outputled>,<trace>);  // init  by theses param  or  #define
//       <handlebalmorsetx>.balcontroletx();   // 
// 
// Traces number:         ..
// ===========================================================================================================

#include "BALM10beep.h"
#include "BALbmorseTx.h"

// fonctions TX   CW et messages cw
#define UTINITIALTX 70    // Unit Time ( dot ) start about CW 13 wpm  see DELAY1MS see table 
#define MAXCODETX   63    // max index pointeur code for table tx
#define TOPCODETX 0x21    // '!'  first car table cw tx  
#define CWTXTONE 	1     // with output  
#define CWTXWAIT 	2     // without ( inter space times )
#define CW_AR		91	  // see end cw tx table 
#define CW_VA		92	
#define CW_AS		93	
#define CW_XX		94	   
#define CW_AT		95    // @ 	

//-----------------------------------------------------------------------------------------------------------
//  table 2    ponct .. , . numbers 0 .. 9 , letters A .. Z , and somes acc. and abrv. méthode org f1bez 1980
//  ascii  48d 30h 0  ,  65d 41h A  , 84d 54h  T  and so on
//  from left to right start with edge 1 to 0 : 111'10'...   allow 6 signs cw   
//  0xFD = 1111101  1 = . (E) , 0xFC = 11111100  0 = - (T) , 0xC0 = 11000000  ----- (0) 
const byte PROGMEM tablemorsetx[MAXCODETX+1] =   
  {
  0xFF,0xAD,0xFF,0xFF,0xFF,0xFF,0xD1,       // ! " # $ % & '  
  0xC9,0x92,0xFF,0xD5,0x8C,0x9E,0xAA,0xCD,  // ( ) * + , - . / 
  0xC0,0xD0,0xD8,0xDC,0xDE,0xDF,0xCF,0xC7,  // 0 ... 7  order is ASCII table
  0xC3,0xC1,0x87,0x95,0xCA,0xCE,0xD5,0xB3,  // 8 9 : ; < = > ?
  0xFF,0xFA,0xE7,0xE5,0xF3,0xFD,0xED,0xF1,  // (sp)  A B  ...  G
  0xEF,0xFB,0xE8,0xF2,0xEB,0xF8,0xF9,0xF0,  // H I J ... O 
  0xE9,0xE2,0xF5,0xF7,0xFC,0xF6,0xEE,0xF4,  // P Q R ... W
  0xE6,0xE4,0xE3,                            // X Y Z   
  0xD5,0xBA,0xD7,0xFF,0xA5                   // 91 AR, 92 VA, 93 AS,94   ,95 @
  };   // MAXCODETX

int unittimetx = UTINITIALTX;
//byte OUTkeycw;   // = 9;	//  prov avec valeurs
//byte OUTled;   // = 11;  // sur teensy 2  suiveur cw visu 
byte paramTx1 = 0;

//--------------------------------------------------------------------------------------------------------
BALMorseTx::BALMorseTx(byte paramcw1)
{
// init
 paramTx1 = paramcw1; // NU réservé
//OUTkeycw = pintx;
//OUTled = ledtx;
//pinMode(OUTkeycw, OUTPUT); // 9 C6 key tx
}

//--------------------------------------------------------------------------------------------------------
// val Unittime 1ms  time            car / mn    wpm / mn ( / 5 ) base PARIS
   // 	    268			27.4		17.5		3.5
   //       100                 10.6		45.2		9   
   //        84			8.7		55		11
   //	     73			7.5		64		13
   //	     41			4.3		111.6		22 
   // as Unittime is 1.5 dot or 1/2 dash  base 1ms   eqv unit 10 timing test on 8 car
   // vit m/mn 8 / unit / 10   *  60 / 5    or  approx word / mn = 960 / unit   

void BALMorseTx::balspeedcwtx(byte speedcw)
{
  unittimetx = 960/speedcw;
} 
//--------------------------------------------------------------------------------------------------------
// #328 inp  type tonalité  ou attente  out  audio   in type  tone or wait , time    out audio
// inp  type note ou silence  
// out  pin  vers filtre bf passe-bas et mixeur bf émission
void BALMorseTx::balcwtxtone(char unsigned type,int ttime)
{
 int demiperiodenote = 1000000 / Mynotebeep / 2;       // en uS 

 switch (type)
  {
  case CWTXTONE :
    digitalWrite(LEDROUGE, HIGH); // idem enveloppe cw   visu cw et relance mono stall ...

   for (int i = 0; i <ttime; i++)
   {
    digitalWrite(ADF7012_TX_DATA_PIN, LOW); //max
    delayMicroseconds(demiperiodenote);
    digitalWrite(ADF7012_TX_DATA_PIN, HIGH);  // 0
    delayMicroseconds(demiperiodenote);
   }
  
    digitalWrite(LEDROUGE, LOW);
    break;
  case CWTXWAIT :	
	
   delay(ttime);
  }	
}

//---------------------------------------------------------------------------------------------------------
// #332   envoie code cw
//  inp car ascii ( 0 ...  Z )   ou caractères spéciaux   
//  out cw 
void BALMorseTx::balsencode(char unsigned car)
{
 char unsigned code;  // byte est 255 sur r3... 
 byte cptbit, testbit, flagstart;
 int ddtime;  // dot dash time
 code = pgm_read_byte(&tablemorsetx[car - TOPCODETX]);  // TOPCODETX is the 1st car of the table tx
 //if (_tracetx)  { Serial.print("code ");  Serial.println(code); }  // if (_tracetx) // car 70 dec  F    -33d   pos 37  donne  237d  EDh
  // num trace  que en dev vérif lettre à lettre
 flagstart = FALSE;           // start clear 
 cptbit = 0x80;               // MSB left first bit
 do 
 {
  testbit = (code & cptbit);  // test 128 64 32 8 ... or  0 if not bit
   if (flagstart == TRUE)     // now bit are data . or _
   {
     if (!testbit)
      {
      // if (_tracetx)  { Serial.print("- ");  Serial.println(code); }  // debug check table tx
	   ddtime = unittimetx * 3;   // dash  3 unit time 
      }
       else
      {
      //if (_tracetx)  { Serial.print(". ");  Serial.println(code); }    // debug
	   ddtime = unittimetx;       // dot 1 unit time 
      }
	 
 	  balcwtxtone(CWTXTONE,ddtime);
	  balcwtxtone(CWTXWAIT,unittimetx);  // end dot or dash add 1 unit time
	  
   }
   // else turn around to find 1st 0
   if (!testbit)  flagstart = TRUE; // first 1>0 is the start mark
   cptbit /=  2;  // next bit ( move bit mask to right 1 ) 
 }while(cptbit >= 1);  // MSB included
 //balcwtxtone(CWTXWAIT,unittimetx * 2); // end car add 2 units time ( total is 3 ) normal
  balcwtxtone(CWTXWAIT,unittimetx * 3); // special plus détaché pour balise...
}

//--------------------------------------------------------------------------------------------------------------
// #334  envoie 1 caractère cw
// inp  code  special     le relais TX1 est déjà ouvert  ou si cde isolé par lractionx 
// out  cw  
// code for somes sp caracters  
// 91 'AR'  ._ ._.  , 92   VA  ..._._  , 93  AS ._..., 94  ,95 @ ._ _ ._.
void BALMorseTx::balsendcar(char  car)
{
 if (car > TOPCODETX && car <= MAXCODETX + TOPCODETX )  
   {
   // if (_tracetx) { Serial.println(car);}
    balsencode(car);
   }
}

//----------------------------------------------------------------------------------------------------------------
// #336   envoie message cw
// inp string   
// out cw 
void BALMorseTx::balsendmessage(byte vitesse,char messagecw[])
{
 byte ii=0;
 char unsigned car;
//if (_tracetx)  {  Serial.print("vitesse ");   Serial.println(vitesse); } 
 if (vitesse > 0) balspeedcwtx(vitesse);  // sinon vitesse en cours
//if (_tracetx)  {  Serial.println(messagecw); } 
//test en dev  if (_tracetx)  { Serial.print("p-intx ");   Serial.println(OUTkeycw); }  // sans if (_tracetx)  {    si pas positionné correctement
   do
   { 
//NU if (digitalRead(INPabort)) { balinfos(97,"fin bt abort ",NOPAR,NODLY); break;}
   car = messagecw[ii++];
    //if (_tracetx)  { Serial.println(car); }  // if (_tracetx)
    switch (car)
	 {
	  case NUL0 :
      break;
    case SPACE :
      balcwtxtone(CWTXWAIT,unittimetx * 4);  // space time words
    } 
     balsendcar(car); // timing et timing intervalle lettre fixes  
   }while(car != NUL0); 
}

//-------------------------------------------
void BALMorseTx::balenvoiecaracterecw(char  car)
{
   balsencode(car);
}

//-------------------------------------------
void BALMorseTx::balenvoieindicatifcw(byte vitesse,char messagecw[])
{
   balsendmessage(vitesse,messagecw);
}

// histoire======================================================================================================
// LOGIQUE BALISE V2.1   Ce fichier est une partie du projet  relais et balises       documentations lr-nnnnn.doc 
// Projet, Etudes, Réalisation, Copyright (c) F5BEZ  ..2015  , AR35 Rennes  ,  R3  et RU3 ,     f5bez-4@orange.fr 
// matériels : Teensy      Development Board   http://www.pjrc.com/teensy/ Copyright (c) 2008, 2010 PJRC.COM, LLC
// compilateur C  :  avr-gcc (WinAVR 20100110) 4.3.3 Copyright (C) 2008 Free Software Foundation, Inc.
// Migration partielle vers ARDUINO + TEENSYDUINO sur TEENSY 2  pour balise F5ZEH  28.231Mhz  QTH du R3 en in88va
//
// Dominique LEVEQUE F5BEZ 
// ==============================================================================================================
