// ===================================================================
// ====   BALM10beep    générateur UHF , balise  pour manips      ====
// ====   ballon sonde météo M10, pll ADF7012B,GPS Sierra, Nano   ==== 
// ====   version 1.0                   F5BEZ Dominique LEVEQUE   ====
// ===================================================================
//
// fonctions RX CW  // ici extraits simplifiés de l'original f5bez  'amorse' 

#include "BALM10beep.h"
#include "BALbtelecomcw.h"  


#define UP        1       // key or bt   repos 1   pull up 
#define DOWN      0       // key down active is 0  <<<
#define UTINITIALRX 130   // Unit Time env 9 wpm cool           télécommandes cw
#define MAXDBNCE     50   // debounce value     shift down key 
#define ELOVERFLOW  1200  // !! see DELAY1MS DEBUG  too      50 > ~ 15 W/mn 43 > ~ 20 W/mn
#define MAXTIME     1000  // preset   must be less  ELOVERFLOW
#define MAXCODERX   128   // max index pointeur code for table rx
#define TEMPSRXCW   3500  // temps creneau télécomm cw    ms
#define TEMPSDEBFCW  10   //   // temps deb fenêtre pour message cw  en 10i de sec
#define TEMPSFINFCW  70   //   // temps fin max alloué pour message cw  en 10i de sec,  delta pour saisie 1 lettre ici

#if defined (FONCTIONSRXCW1CAR)

// rx cw

int Unittimerx = UTINITIALRX;
int unsigned  ELtime;    // ELapsed time           see  diagrams
int unsigned  DDtime;   // Dot-Dash time
int unsigned  LStime;   // Letter Space time
byte ndebounce;      // nbre pass debounce key 
byte cptdebounce;    // counter n cycles low before flag
bool statKEY;        // inp straight key or rx filter from audio 
bool flagKEY = UP;     // int flagKEY;      // 0 hight 1 low straight key cw
bool flagDD = FALSE;       // 1 if DD time reached 
bool flagLS = FALSE;     // 1 if LS time reached
bool flagendamorse;  // 0 run 1 stop 
byte caractcwcde;    // the ascii cw letter...   or command 
byte cptrxcode = 1;    // code counter for rx        if < 255  
int  cpttempsrxcw;

byte cptlettretelec = 0;
char lettrerxcw1 = ' ';
//char lettrerxcw2 = ' ';

bool  Flagrequestcdecw = 0;



//  control
byte    cptpassefct = 0;  // tests de contrôle
int     cpttempsattenteenstby = 0;     
int     cpttempsporteuseactive = 0;     
bool    flagcyclefrontouvert = 0;     
byte    cptnbrelettrescw = 0;     
bool    flagtempsfenetrerxcw = 0;   

///  pour ce module ctrl  en usb pc   pas prévu out bluetooth 
int trace = 0;   // en dev   0 ou 1 

//-----------------------------------------------------------------------------
// table 1 of ascii caracters and somes pseudo caracters for particulars cw cases
// code is the index computed by the algorithm  dash-dot       
 const byte PROGMEM tablemorserx[MAXCODERX+1] =
    {
  0x20, ////               pt 0
  0x20, ////               code from  1  not used 
  'E',    // E: .        //  see dot  >  * 2      = 2  >   E 
  'T',  // T: -        //  see dash >  * 2 + 1  = 3  >   T  
  'I',  // I: ..       //  second pass      2 * 2 
  'A',  // A: ._       //  second pass      2 * 2 + 1
  'N','M','S','U','R',                             // 10
  'W','D','K','G','O','H','V','F',0x20,'L',       // 20
  0x20,'P','J','B','X','C','Y','Z','Q',0x20,      // 30
  0x20,'5','4','#','3','?',0x20,'?','2','&',      // 40           # reserved header
  0x20,'+',0x20,0x20,0x20,0x27,'1','6','=','/',   // 50  42 +  46  ' (hex)  49  =
  0x20,0x20,';','(',0x20,'7',',',0x20,0x20,'8',   // 60
  0x20,'9','0',0x20,                   // 64
    // ponctuations    but somes variants exist ! here international code !  
  0x20,0x20,0x20,0x20,'.',0x20,  // 70     69  . = VA
  0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,  // 80
  0x20,0x22,0x20,0x20,'.',0x20,0x20,0x20,0x20,'@',    // 90  @   82  " (hex) 85 . 
  0x20,0x20,0x20,0x20,0x20,0x20,'-',0x20,0x20,0x20,   // 100     97 - 
  0x20,0x20,0x20,0x20,0x20,';','!',0x20,')',0x20,     // 110     106  ;  109  )
  0x20,0x20,0x20,0x20,',',0x20,0x20,0x20,0x20,':',    // 120 :     115  , 
  0x20,0x20,0x20,0x20,0x20,0x20,0x20  // 127  +0      
  };      //MAXCODERX                                     nb not $ INDCAR  % end line


//--------------------------------------------
// #500 read key, integration bounces, timing testing, setting flags
// fcttime  normal 1 figé           référence version simplifiée de amorse f5bez 
// avec filtre rebonds, sans moyennage, sans auto adaptation différents algo.  DD et LS figés ici
// prévu pour manip lente pour entrer d'ordre cw à une lettre ici avec 1 bt std
void balstatuskeyrx(byte option,int fcttime)
{
  delay(1);      // <<< here important it's the sampling time !!!!
  flagDD = FALSE;  // clear flags 
  flagLS = FALSE;
  option = option; // nu ici  warning skip
  statKEY =  digitalRead(BT1CTRL);   // repos key up 1 ( pullup ) down  à 0     intégration rebonds
  if (  statKEY  == UP ) cptdebounce++;  else cptdebounce = ndebounce+1; // croît en mS avant de décider si 'up'
  if (( statKEY  == UP ) && ( cptdebounce > ndebounce  ))   { cptdebounce = 0;  flagKEY = UP;  }   // UP  
  if (  statKEY  == DOWN )  cptdebounce++;  else   cptdebounce = ndebounce+1;   // croît en mS avant de décider si 'down   
  if (( statKEY  == DOWN ) && ( cptdebounce > ndebounce  )) { cptdebounce = 0;  flagKEY = DOWN; }  // DOWN 
  if ( flagKEY == DOWN )  digitalWrite(LEDROUGE, HIGH);  else  digitalWrite(LEDROUGE, LOW); // 'down' led on
  ELtime++; // ELapsed time grown here by step 1ms  
  if ( ELtime > ELOVERFLOW )  ELtime = MAXTIME;   // if too  long   presetting to max time   
  if ( ELtime >= (LStime * fcttime ))  flagLS = TRUE;   // end letter !
  if ( ELtime >= DDtime )  flagDD = TRUE;       // this a dash  else a dot !   
}
//--------------------------------------------
//  #540 in code out return ascii caracter related from code  and his abrev in bufferabrv
//https://www.arduino.cc/reference/en/language/variables/utilities/progmem/
char unsigned baldecoderx (int code)
{
  byte car;
  car = pgm_read_byte(&tablemorserx[code]);
  return(car);
}
//--------------------------------------------
// #840  Fcts rx cw decode    see flowchart  
void balrxcwkeystart(void)
{ 
  ndebounce = MAXDBNCE;
  cptdebounce = 0;    
  Unittimerx = UTINITIALRX;
  DDtime = Unittimerx * 3 / 2;      // half of dash 
  LStime = Unittimerx * 3;          // at least 
  
}     
  
//--------------------------------------------  
// #860 Key  up    here heart loop wait    version différente ici 
void balrxcwkeyup(void)
{
  do      // loop wait key up             
  {
   // now  here  turn around waiting for something ( each end word ) ... 
  balstatuskeyrx(0,1);     //          ex normal 1  ( not  endlettertime  ) 
  cpttempsrxcw++;
   if( cpttempsrxcw > TEMPSRXCW ) break;     //     fin attente créneau
  /// temps attente télécommande par cw  fenêtre x  sec   hors cycles stall time out ... 
  }while(flagKEY==UP);
}

//--------------------------------------------
// #870 key down   here    see rx flowchart  ici version simplifiée 
void balrxcwkeydown(void)
{
byte cptrxcodeloc;    // must be local
cptrxcodeloc = cptrxcode; // take global old
  // key down :  start
  keydown:
  ELtime = 0;
    do     // loop ELapsed time grow...
    {
    balstatuskeyrx(0,1);          // normal 1  ( not  endlettertime  ) 
    cpttempsrxcw++;
    if( cpttempsrxcw > TEMPSRXCW ) break;
    }while(flagKEY==DOWN);
    // key up   what about ELtime   is it < or >  DD  ?
  if (flagDD==TRUE)        // over current DDtime or not !
  {
    // ------ dash   
    //  >>>>>>> fonction auto adaptative non utilisée
    //   LStime =  (ELtime / 2) + DDtime ;  // on average last dashes 
    //   DDtime =  LStime / 2;
     // methode for ' code ' computation and a table with the cw ' abbreviations ' 
     // here is the way for unique sequence  dash is n time multiple of 2 + 1
    cptrxcodeloc *= 2;  // code X 2
    cptrxcodeloc++;     // + 1 
  }
  else
  {
    // -------- dot 
    //  >>>>>>> fonction auto adaptative non utilisée  ici 
    //      DDtime = ELtime * 2; 
    // here is the way for unique sequence  dot is n time multiple of 2 
    cptrxcodeloc *= 2;             // code x 2
  }
    // -------- key up  return   wait  
  // here test a limit of code calculation , in regard of the morse table
  if ( cptrxcodeloc > MAXCODERX )
  {
   cptrxcodeloc /= 2;           //code / 2  arbitrairy back
  }
  else
  {
    ELtime = 0;             // clear and recycle
    do      // wait up   is it  end letter ?
    {
    balstatuskeyrx(0,1);              // normal 1  ( not  endlettertime  ) 
    cpttempsrxcw++;
     if( cpttempsrxcw > TEMPSRXCW ) break;
      if ( flagKEY == DOWN )
      {
       goto keydown;        // down ! so continue
      }
    }while( flagLS == FALSE );
  }
  
  // ---------- key up  end letter  !
  // here code has grown with dot and dash 
  ELtime = 0;                   // clear and recycle  for testing end word
  caractcwcde = baldecoderx(cptrxcodeloc);      // code is offset for rx table
  cptrxcodeloc = 1;                 // clear after use for next step
  // version ici   get 1 seule lettre
  if (cptlettretelec == 1 ) lettrerxcw1 = caractcwcde;
  //if (cptlettretelec == 2 ) lettrerxcw2 = caractcwcde;
    
  cptlettretelec++;
  if (cptlettretelec > 2 )  cptlettretelec = 3; ///// max à 1 et 2  3 fin pour 2 lettres
   // here it's an hole in the cycle Rx but no matter, run the command and follow here...
   //mcommandbycar(caractcwcde);
   caractcwcde = SPACE; // acq
    //>>>>> fonction attente de fin mot non utilisée
  cptrxcode = cptrxcodeloc;  // store for next pass
  // to key up       finish !! 
} 

   
//
//--------------------------------------------
// fct réception cw pour 2 lettres dans créneau temps alloué 
byte balfenetrerxcw(void)
{ 
  cpttempsrxcw = 0;
  flagendamorse = FAUX;  // pour cpt et sortie fonction à temps fin
  cptlettretelec = 1;    // 0 N.U.   3 si sortie avec 2 lettres et maxi
 
  lettrerxcw1 = ' ';
  //lettrerxcw2 = ' ';    // simplifié à 1 lettre
  
  while (!flagendamorse)
  {
    balrxcwkeystart();   // which key ?
    balrxcwkeyup();      // with others fcts when up ( when waiting )  
    if( cpttempsrxcw > TEMPSRXCW ) break;  // attente UP  dépassée
    balrxcwkeydown();    // decode
    if( cpttempsrxcw > TEMPSRXCW ) flagendamorse = VRAI;
  }  
  return (cptlettretelec);
}

    
//---------------------------------------------------------------.
// cette fonction lit l'état inp signal  bt1 ctrl  
// Un temps d'ouverture d'au moins x sec, valide une zone de temps de y sec pour entrer en cw   n caractères de télécommande
void balcontrolerx(void)
{
 do
  {
  delay(100);  // donne la cadence d'échantillonnage 
  if (digitalRead(BT1CTRL))  // si signal 1 KUP en attente  ou retour key up
  {
   //-- retombée porteuse  pour  modes controle télécomm rx cw  
   if (flagtempsfenetrerxcw == VRAI)     // zone temps analyse pulses porteuse 
   {
    cptnbrelettrescw = balfenetrerxcw(); // traiter rx cw      zone temps allouée   
    //if (trace) {Serial.print("traiter cw "); Serial.println(cptnbrelettrescw); }   
    if (cptnbrelettrescw == 2) 
      {
       Flagrequestcdecw = FAUX;  // acq
       cptnbrelettrescw = 0; // en +
       flagcyclefrontouvert = FAUX; // en +
      }

      cpttempsporteuseactive = TEMPSFINFCW+1;  // force sortie après temps fenêtre rx cw
    if (cpttempsporteuseactive > TEMPSFINFCW )    // si fin temps alloueé et retour 0 , traiter
     {
     digitalWrite(LEDVERTE, LOW);   
     if (trace) {Serial.println("fin TO 1 ");  }
     cpttempsporteuseactive = 0;         // acquitte progression 
     flagtempsfenetrerxcw = FAUX;        // acquitte zone temps 
     } // de temps final à  s
   }  // de zone pulses   à   s
   else  // retour up  pour la fonction control report
   {  
    cpttempsporteuseactive = 0;
    cptnbrelettrescw = 0;
    flagcyclefrontouvert = FAUX;  // pour détection front up de 0 à 1
    if ( cpttempsporteuseactive < TEMPSDEBFCW ) 
     {
      Flagrequestcdecw = FAUX;  // désarme 
     }  
   }
   cpttempsattenteenstby++;      // progression temps attente up    reset à down
   if (cpttempsattenteenstby == 100 )  if (trace)  {Serial.println("att 10");}    
  }  // de BT1CTRL à 1 
   else
  {  // key à 0 signal down
  if (flagtempsfenetrerxcw == VRAI)         // si dans la zone    a  sec  
   {
    
   }
  cpttempsporteuseactive++;   // progression temps  , reset à cycles si down à 0  hors   à  
  if ((cpttempsporteuseactive > TEMPSFINFCW) && ( flagtempsfenetrerxcw == VRAI))   // au delà   s 
   {
   digitalWrite(LEDVERTE, LOW);
   digitalWrite(LEDROUGE, LOW); 
   if (trace) {Serial.println("fin TO 2 ");  } // qu'une fois
   flagtempsfenetrerxcw = FAUX;   // fin temps zone   
   cpttempsporteuseactive = 0;     // recycle 
   }
   if ((cpttempsporteuseactive == TEMPSDEBFCW) && (flagcyclefrontouvert == FAUX)) // au delà    s
    {
     flagcyclefrontouvert = VRAI; 
     flagtempsfenetrerxcw = VRAI;    // début temps zone
     flagcyclefrontouvert = VRAI;    // force  pas détection de ce front en cours
     digitalWrite(LEDVERTE, HIGH);
     if (trace) {Serial.println("deb zone ");  } 
    }
    else  // à down  attente des n sec  Flagrequestcdecw  est armé 
    {
    //Serial.print("att zone ");Serial.println( cpttempsporteuseactive );  // trop traces
    }
   if (cpttempsporteuseactive ==  100 )       // progression temps down  
   {
   if (trace) {Serial.println("down 10s");} // porteuse 1mn 
   digitalWrite(LEDROUGE,HIGH); // add  down  trop long
   }
   cpttempsattenteenstby = 0;  
  } // de down
 }while ( Flagrequestcdecw == VRAI ); 
}

// --------------------------------------------------------------------
byte balreceptioncencw(void)
 {
  byte numaction = 0;
  
 if (( digitalRead(BT1CTRL) == 0 )  && ( Flagrequestcdecw == FAUX ))   // si signal 1 en attente  ou retour key up
    {
     Flagrequestcdecw = VRAI;
     digitalWrite(LEDVERTE, OFF);
     delay(100);
     lettrerxcw1 = ' ';
     balcontrolerx(); 
     balprints("\r\nRxCw:"); balprintc(lettrerxcw1); balprintretourligne;
     /// !! pas de vérif 
     /// on skip certaines commandes  qui impliquent un retour en saisie ligne
     numaction = 0;  // def
     //if ((lettrerxcw1 == ' ')  ||  (lettrerxcw1 == ' ')  ||  (lettrerxcw1 == ' ')) // à voir
     //    balacqreponse(BEEPNOK);
     //else
     // personnalisation à ce prg balm10beep :
     // lettres autorisées en fct balbfonctions à baltelecommandelettre   pour cde de bases  dont chgt en eeprom
     if ( (lettrerxcw1 == 'T')  ||  (lettrerxcw1 == 'B') ||  (lettrerxcw1 == 'V') ||  (lettrerxcw1 == 'P') ||  (lettrerxcw1 == 'Q') || \
          (lettrerxcw1 == 'M')  ||  (lettrerxcw1 == 'S') ||  (lettrerxcw1 == 'C') ||  (lettrerxcw1 == 'L') ||  (lettrerxcw1 == '0') || \
          (lettrerxcw1 == 'J')  ||  (lettrerxcw1 == '1') ||  (lettrerxcw1 == '2') ||  (lettrerxcw1 == '3') ||  (lettrerxcw1 == '4') )
      {    
       numaction = baltelecommandelettre(0,lettrerxcw1);  // traite équiv en codeaction
       // balprintln("\nNoActionCW:",numaction);
       return(numaction);
      }  
      else
       balacqreponse(BEEPNOK);
    }
  //else     // pas de key
    return(0);
 }   

#endif

// Dominique LEVEQUE F5BEZ 
// ==============================================================================================================
